#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "popaccdlgs.h"
#include "popprofdlg.h"
#include "global.h"
#include "popretdlg.h"
#include "qspop3ver.h"
#include "fileman.h"

USERES("QSpop\QSpop3.res");
USEUNIT("QSpop\QSpop3Ver.cpp");
USEFORM("QSpop\PopPassDlg.cpp", PassDlg);
USEFORM("QSpop\PopProfDlg.cpp", AccProfDlg);
USEFORM("QSpop\PopRetDlg.cpp", PopRetrDlg);
USEFORM("QSpop\PrintDlgs.cpp", PrintForm);
USEFORM("QSpop\WipeDlgs.cpp", WipeDlg);
USEFORM("QSpop\HelpDlgs.cpp", HelpDlg);
USEFORM("QSpop\View.cpp", ViewDlg);
USEUNIT("QSpop\Mixmaster.cpp");
USEUNIT("QSpop\FileMan.cpp");
USEUNIT("QSpop\HeadMan.cpp");
USEUNIT("QSpop\Global.cpp");
USEFORM("QSpop\MsgBoxDlgs.cpp", MsgBoxDialog);
USEFORM("QSpop\MixDlgs.cpp", MixForm);
USEFORM("QSpop\POPProxyDlgs.cpp", ProxyDlg);
USELIB("QSpop\zlib.lib");
USEFORM("QSpop\PopAccDlgs.cpp", PopAcctDlg2);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport)  void __fastcall GetPop3Mail(TForm *MainForm,
   HWND AppHandle, bool UseDialog);
extern "C" __declspec(dllexport) char* __fastcall GetPop3Name();
extern "C" __declspec(dllexport) char* __fastcall GetPop3Version();
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
char* __fastcall GetPop3Name()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------

char* __fastcall GetPop3Version()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------

void __fastcall GetPop3Mail(TForm *Owner, HWND AppHandle, bool UseDialog)
{
   TheMainForm = Owner;
   Application->Handle = AppHandle;
   TStringList *accts = new TStringList();
   GetAppData(accts, PopAccounts);

   // convert data to new format if necessary
   bool needsave = false;
   TStringList *acct = new TStringList();
   for (int i = 0; i < accts->Count; i++)
   {
      acct->Clear();
      AnsiString item, line = accts->Strings[i];
      if (line.Pos("checked=") == 1 || line.Pos(POPDATDIV) > 0) // old format--checked at beginning of string
      {
         needsave = true;
         int x = 0; while ((item = GetToken(x, line, POPDATDIV)) != "" && item != "end=1")
         {
            if (item.Pos("account=") == 1)
            {
               int p = item.Pos(POPACCDIV);
               if (p > 0)
                  item[p] = '@';
            }
            acct->Add(item);
            x++;
         }
         acct->Move(0, acct->Count - 1);
         accts->Strings[i] = acct->CommaText;
      }
   }
   if (needsave)
      PutAppData(PopAccounts, accts);
   delete acct;

   // get down to business
   if (!UseDialog)
   {
      int i=0; while (i<accts->Count)
      {
         if (accts->Strings[i].LowerCase().Pos("checked=1")==0)
             accts->Delete(i); else i++;
      }
      if (accts->Count)
      {
         PopRetrieveMail(accts, Owner, Owner);
         delete accts;
         return;
      }
   // no accounts -- fall through here
   }

   if (OpenPopAccountsDlg(Owner, accts))
      PutAppData(PopAccounts, accts);

   delete accts;
}
//---------------------------------------------------------------------------
