//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "global2.h"
#include "AskUpdateDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAskUpdateDlg *AskUpdateDlg;
//---------------------------------------------------------------------------

bool __fastcall AskUpdateMail2newsGateways(TForm *Owner, TStrings *Proxy)
{
   if (SecureModeMsg(Owner))
      return false;

   AskUpdateDlg = new TAskUpdateDlg(Owner);

   AskUpdateDlg->Caption = "Update mail2news.txt";
   AskUpdateDlg->Label2->Caption = "Go online and update mail2news.txt now?";

   AskUpdateDlg->ShowModal();
   bool ok = AskUpdateDlg->ModalResult == mrOk;
   if (ok)
   {
      int index = AskUpdateDlg->ProxyBox->ItemIndex;
      if (index >= 0)
      {
         Global->DB->GetProxy(AskUpdateDlg->ProxyBox->Items->Strings[index], Proxy);
      }
   }

   delete AskUpdateDlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall AskUpdateNymserverKeys(TForm *Owner, TStrings *Proxy)
{
   if (SecureModeMsg(Owner))
      return false;

   AskUpdateDlg = new TAskUpdateDlg(Owner);

   AskUpdateDlg->Caption = "Update nymserver.asc";
   AskUpdateDlg->Label2->Caption = "Go online and update nymserver.asc now?";

   AskUpdateDlg->ShowModal();
   bool ok = AskUpdateDlg->ModalResult == mrOk;
   if (ok)
   {
   }

   delete AskUpdateDlg;
   return ok;
}

//---------------------------------------------------------------------------
// AskUpdateDlg
//---------------------------------------------------------------------------

__fastcall TAskUpdateDlg::TAskUpdateDlg(TComponent* Owner)
        : TForm(Owner)
{
   ProxyBox->Clear();
   ProxyBox->ItemHeight = 16;
   ProxyBox->Sorted = true;

   TStrings *proxies = new TStringList();
   Global->DB->GetProxies(proxies);

   for (int i = 0; i < proxies->Count; i++)
   {
      AnsiString line = proxies->Strings[i];
      if (GetTok(ProxyHTTP, line, ',') != " ")
         ProxyBox->Items->Add(line);
   }

   ProxyBox->Sorted = false;
   ProxyBox->Items->Insert(0, "<none>");

   TColor color;
   TIniFile *ini = new TIniFile(AppIni());

   LoadFonts(ini, NymIni, color, Font, ProxyBox->Font, NULL);
   ProxyBox->Color = color;

   OrgProxy = ini->ReadString(/*NymIni*/ "nym", "lasthttpproxy", "<none>");
   int index = ProxyBox->Items->IndexOf(OrgProxy);
   if (index < 0)
   {
      //MsgBox((TForm*)Owner,
      //  "The proxy you have been using for mail2news/nymserver keys     \n"
      //  "retrieval--" + GetTok(0, last, ProxyDiv) + "--is no longer present!",
      //   MT_WARN, MB_OK
      //);
      index = 0;
   }
   delete ini;

   ProxyBox->ItemIndex = index;

   delete proxies;
}
//---------------------------------------------------------------------------

void __fastcall TAskUpdateDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   int index = ProxyBox->ItemIndex;
   AnsiString proxy;

   if (index >= 0)
   {
      proxy = ProxyBox->Items->Strings[index];
   }
   else
   {
      proxy = "<none>";
   }

   if (proxy != OrgProxy)
   {
      TIniFile *ini = new TIniFile(AppIni());
      ini->WriteString(/*NymIni*/ "nym", "lasthttpproxy", proxy);
      delete ini;
   }
}
//---------------------------------------------------------------------------

void __fastcall TAskUpdateDlg::ProxyBoxDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
   TCanvas *Canvas = ProxyBox->Canvas;
   Canvas->FillRect(Rect);
   AnsiString item, proxystr = ProxyBox->Items->Strings[Index] + ",";
   item = GetTok(0, proxystr, ',');
   Canvas->TextRect(Rect, Rect.left + 2, Rect.top + 1, item);
}
//---------------------------------------------------------------------------

