//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "ListManDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TListManDlg *ListManDlg;
//---------------------------------------------------------------------------

bool __fastcall ManageMail2newsTxt(TForm *Owner, const AnsiString &FileName)
{
   ListManDlg = new TListManDlg(Owner, FileName);
   ListManDlg->ShowModal();
   bool ok = ListManDlg->ModalResult == mrOk;
   delete ListManDlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall ManageNymserverAsc(TForm *Owner, const AnsiString &FileName)
{
   ListManDlg = new TListManDlg(Owner, FileName);
   ListManDlg->Caption = " Nymserver.asc Manager";
   ListManDlg->Width = 550;
   ListManDlg->ShowModal();
   bool ok = ListManDlg->ModalResult == mrOk;
   delete ListManDlg;
   return ok;
}

//---------------------------------------------------------------------------
// TListManDlg
//---------------------------------------------------------------------------

__fastcall TListManDlg::TListManDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TListManDlg::TListManDlg(TComponent* Owner, const AnsiString &FileName)
        : TForm(Owner)
{
   list = new TStringList();
   filename = FileName;

   if (FileExists(filename))
   {
      Editor->Lines->LoadFromFile(filename);
   }

   Editor->Modified = false;
   Label1->Caption = "";
}
//---------------------------------------------------------------------------

__fastcall TListManDlg::~TListManDlg()
{
   delete list;
}
//---------------------------------------------------------------------------

void __fastcall TListManDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified)
   {
      if (ModalResult == mrCancel)
      {
         switch (MsgBox(this,
            "Your list is modified. Save Your changes?", MT_CONFIRM, MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: return;
         }
      }

      Editor->Lines->SaveToFile(filename);
   }
}
//---------------------------------------------------------------------------

void __fastcall TListManDlg::SetToolbarButtons()
{
   PasteBtn->Enabled = Clipboard()->HasFormat(CF_TEXT);
   bool hassel = Editor->SelLength > 0;
   CopyBtn->Enabled = hassel;
   CutBtn->Enabled = hassel;
}
//---------------------------------------------------------------------------

void __fastcall TListManDlg::PopupMenuPopup(TObject *Sender)
{
   PopPasteItem->Enabled = Clipboard()->HasFormat(CF_TEXT);
   bool hassel = Editor->SelLength > 0;
   PopCopyItem->Enabled = hassel;
   PopCutItem->Enabled = hassel;
}
//---------------------------------------------------------------------------

void __fastcall TListManDlg::EditorSelectionChange(TObject *Sender)
{
   SetToolbarButtons();
}
//---------------------------------------------------------------------------
