//---------------------------------------------------------------------------
#ifndef NymConfigsH
#define NymConfigsH
#include "nymprofiles.h"
#include "pgpsdk.h"

class TNymConfig : public TObject
{
public:
   TForm *Owner;
   TPGPsdk *PGP;
   TNymProfile *profile;

   __fastcall TNymConfig(TForm *Owner, TPGPsdk *PGP, TNymProfile *Profile);
   __fastcall~TNymConfig();

   bool __fastcall CreateNymCreateMessage(TStrings *Template, bool preview);
   bool __fastcall CreateModifyMessage(TStrings *Template, bool preview,
      bool commands, bool key, bool replyblock, AnsiString SignKey);
   bool __fastcall CreateDeleteMessage(TStrings *Template);
   bool __fastcall CreateReplayMessage(TStrings *Template);
   bool __fastcall CreateFromNymMessage(TStrings *Template);

private:
   AnsiString __fastcall CreateMessagePGPHeader(const AnsiString &PGPKeyID,
      const AnsiString &NymserverKeyID);
   void __fastcall CopyTemplateToMessage(TStrings *Message, TStrings *Template);
   void __fastcall PlaceMessageHeader(TStrings *Message, const AnsiString &Header,
      const AnsiString &Value);

  bool __fastcall GetNymserverKey(const AnsiString &nymserver, TStrings *key);
  int __fastcall GetHeaderPos(const AnsiString &header);
};

//---------------------------------------------------------------------------
#endif
