//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymDelFrames.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDelFrame *DelFrame;
int const mNone = 0;
int const mExt = 1;
//---------------------------------------------------------------------------

/*void __fastcall SetAnonToDirectives(TForm *Owner, TGroupBox *DelGroup, AnsiString &AnonTo,
   AnsiString &RemixTo, AnsiString &EncryptTo, AnsiString &RemailTo,
   AnsiString &TestTo, AnsiString &Password,
   const AnsiString &Caps, bool Last)
{
   DelFrame = new TDelFrame(Owner);
   DelFrame->Parent = DelGroup;

   DelFrame->AnonTo->Text = AnonTo;
   DelFrame->RemixTo->Text = RemixTo;
   DelFrame->EncryptTo->Text = EncryptTo;
   DelFrame->RemailTo->Text = RemailTo;
   DelFrame->TestTo->Text = TestTo;
   DelFrame->Password->Text = Password;
   DelFrame->Caps = Caps;
   DelFrame->Last = Last;

   DelFrame->SetToggles();
}
//---------------------------------------------------------------------------

void __fastcall GetAnonToDirectives(AnsiString &AnonTo, AnsiString &RemixTo,
   AnsiString &EncryptTo, AnsiString &RemailTo, AnsiString &TestTo,
   AnsiString &Password, const AnsiString &Caps, bool Last)
{
   AnonTo = DelFrame->AnonTo->Text;
   RemixTo = DelFrame->RemixTo->Text;
   EncryptTo = DelFrame->EncryptTo->Text;
   RemailTo = DelFrame->RemailTo->Text;
   TestTo = DelFrame->TestTo->Text;
   Password = DelFrame->Password->Text;
}*/
//---------------------------------------------------------------------------

__fastcall TDelFrame::TDelFrame(TComponent* Owner)
        : TFrame(Owner)
{
   AnonToBtn->Left = AnonToBox->Left;
   RemixToBtn->Left = RemixToBox->Left;
   EncryptToBtn->Left = EncryptToBox->Left;
   RemailToBtn->Left = RemailToBox->Left;
}
//---------------------------------------------------------------------------

bool __fastcall TDelFrame::HasCap(const AnsiString &Cap)
{
   return Caps.Pos(" " + Cap + " ") > 0;
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::EnableControl(TEdit *Control, bool Enable)
{
   Control->Color = Enable ? clWindow : clBtnFace;
   Control->Enabled = Enable;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TDelFrame::GetAnonToAddress()
{
   AnsiString address, tmp = AnonTo->Text;
   if (!tmp.IsEmpty())
      return tmp;

   if (tmp.IsEmpty())
      tmp = RemixTo->Text;
   if (tmp.IsEmpty())
      tmp = EncryptTo->Text;
   if (tmp.IsEmpty())
      tmp = RemailTo->Text;

   for (int i = tmp.Length(); i > 0; i--)
   {
      if (tmp[i] == ',' || tmp[i] == ' ')
         break;

      address = AnsiString(tmp[i]) + address;
   }

   return address;
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::SetToggles()
{
   bool remix = HasCap("remix");
   if (Last || !remix)
   {
      RemixToChainBtn->Enabled = false;
      RemixToBtn->Enabled = false;
      RemixToBox->Enabled = false;
      RemixTo->Enabled = false;
      RemixTo->Color = clBtnFace;
   }

   bool repgp = HasCap("repgp");
   if (Last || !repgp)
   {
      EncryptToChainBtn->Enabled = false;
      EncryptToBtn->Enabled = false;
      EncryptToBox->Enabled = false;
      EncryptTo->Enabled = false;
      EncryptTo->Color = clBtnFace;
   }

   mode = HasCap("ext") ? mExt : mNone;

   if (mode == mNone)
   {
      AnonToBtn->Visible = true;
      AnonToBox->Visible = false;

      RemixToBtn->Visible = true;
      RemixToBox->Visible = false;

      EncryptToBtn->Visible = true;
      EncryptToBox->Visible = false;

      RemailToBtn->Visible = true;
      RemailToBox->Visible = false;

      RemixToChainBtn->Visible = false;
      RemixTo->Width = AnonTo->Width;
      EncryptToChainBtn->Visible = false;
      EncryptTo->Width = AnonTo->Width;

      if (!AnonTo->Text.IsEmpty())
         AnonToBtn->Checked = true;
      else if (!RemixTo->Text.IsEmpty())
         RemixToBtn->Checked = true;
      else if (!EncryptTo->Text.IsEmpty())
         EncryptToBtn->Checked = true;
      else if (!RemailTo->Text.IsEmpty())
         RemailToBtn->Checked = true;
   }
   else
   {
      AnonToBtn->Visible = false;
      AnonToBox->Visible = true;

      RemixToBtn->Visible = false;
      RemixToBox->Visible = true;

      EncryptToBtn->Visible = false;
      EncryptToBox->Visible = true;

      RemailToBtn->Visible = false;
      RemailToBox->Visible = true;

      if (!AnonTo->Text.IsEmpty())
         AnonToBox->Checked = true;
      if (HasCap("remix") && !RemixTo->Text.IsEmpty())
         RemixToBox->Checked = true;
      if (HasCap("repgp") && !EncryptTo->Text.IsEmpty())
         EncryptToBox->Checked = true;
      if (!RemailTo->Text.IsEmpty())
         RemailToBox->Checked = true;

      if (!AnonToBox->Checked)
         EnableControl(AnonTo, false);
      if (!RemixToBox->Checked)
      {
         EnableControl(RemixTo, false);
         RemixToChainBtn->Enabled = false;
      }
      if (!EncryptToBox->Checked)
      {
         EnableControl(EncryptTo, false);
         EncryptToChainBtn->Enabled = false;
      }
      if (!RemailToBox->Checked)
         EnableControl(RemailTo, false);
   }

   AnsiString addr = GetAnonToAddress();
   if (AnonTo->Text.IsEmpty())
      AnonTo->Text = addr;

   if (!Last && remix && RemixTo->Text.IsEmpty())
      RemixTo->Text = addr;
   if (!Last && repgp && EncryptTo->Text.IsEmpty())
      EncryptTo->Text = addr;

   if (RemailTo->Text.IsEmpty())
      RemailTo->Text = addr;

   RemixTo->Modified = false;
   EncryptTo->Modified = false;
   TestTo->Modified = false;
   Password->Modified = false;
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::AnonToBtnClick(TObject *)
{
   EnableControl(AnonTo, true);
   EnableControl(RemixTo, false);
   EnableControl(EncryptTo, false);
   EnableControl(RemailTo, false);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::RemixToBtnClick(TObject *)
{
   EnableControl(AnonTo, false);
   EnableControl(RemixTo, true);
   EnableControl(EncryptTo, false);
   EnableControl(RemailTo, false);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::EncryptToBtnClick(TObject *)
{
   EnableControl(AnonTo, false);
   EnableControl(RemixTo, false);
   EnableControl(EncryptTo, true);
   EnableControl(RemailTo, false);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::RemailToBtnClick(TObject *)
{
   EnableControl(AnonTo, false);
   EnableControl(RemixTo, false);
   EnableControl(EncryptTo, false);
   EnableControl(RemailTo, true);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::AnonToBoxClick(TObject *)
{
   EnableControl(AnonTo, AnonToBox->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::RemixToBoxClick(TObject *)
{
   bool checked = RemixToBox->Checked;
   RemixToChainBtn->Enabled = checked;
   EnableControl(RemixTo, checked);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::EncryptToBoxClick(TObject *)
{
   bool checked = EncryptToBox->Checked;
   EncryptToChainBtn->Enabled = checked;
   EnableControl(EncryptTo, checked);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::RemailToBoxClick(TObject *)
{
   EnableControl(RemailTo, RemailToBox->Checked);
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::TestToExit(TObject *)
{
   if (!TestTo->Text.IsEmpty())
   {
      EnableControl(Password, true);
      Label1->Enabled = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::TestToChange(TObject *)
{
   bool enable = !TestTo->Text.IsEmpty();
   Password->Enabled = enable;
   Password->Color = enable ? clWindow : clBtnFace;
   Label1->Enabled = Password->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::PasswordEnter(TObject *)
{
   if (Password->Text.IsEmpty())
      Password->Text = GetEncryptKey();
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::RemixToChainBtnClick(TObject *)
{
   AnsiString remixto = RemixTo->Text;
   //if (EditRemixEncryptChain(this, "Select Remix-To Remailer Chain", remixto))
   {
      RemixTo->Text = remixto;
      RemixTo->Modified = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TDelFrame::EncryptToChainBtnClick(TObject *)
{
   AnsiString encryptto = EncryptTo->Text;
   //if (EditRemixEncryptChain(this, "Select Encrypt-To Remailer Chain", encryptto))
   {
      EncryptTo->Text = encryptto;
      EncryptTo->Modified = true;
   }
}
//---------------------------------------------------------------------------

bool __fastcall TDelFrame::ValidAddress(AnsiString Address)
{
   if (Address.IsEmpty() || (mode == mExt && Address.LowerCase() == "me"))
      return true;

   int at = 0; for (int i = 0; i < Address.Length(); i++)
      if (Address[i] == '@')
         at++;

   if (at > 1)
   {
      MsgBox((TForm*)Owner,
         "Your Test-To address is not a valid email address!   ",
          MT_INFO, MB_OK);
      return false;
   }

   at = Address.Pos("@");
   int pt = Address.SubString(at + 1, 256).Pos(".");
   if (at == 0 || pt == 0)
   {
      MsgBox((TForm*)Owner, "Your Test-To address is not a valid email address!   ",
         MT_INFO, MB_OK);
      return false;
   }

   return true;
}
//---------------------------------------------------------------------------

/*void __fastcall TDelFrame::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrCancel)
   {
      if (RemixTo->Modified || EncryptTo->Modified || TestTo->Modified || Password->Modified)
      {
         switch(MsgDlg(this, "Your delivery options are modified. Save your changes?   ", "Confirm",
            MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: return;
            case IDYES: ModalResult = mrOk;
         }
      }
   }

   if (ModalResult == mrOk)
   {
      if (!ValidAddress(TestTo->Text))
      {
         CanClose = false;
         return;
      }
   }
}*/
//---------------------------------------------------------------------------
