//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymGenCfgNowDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymGenCfgNowDlg *NymGenCfgNowDlg;
//---------------------------------------------------------------------------

bool __fastcall GenNymCreateMessage(TForm *Owner, bool &Preview, TStrings *Template)
{
   if (SecureModeMsg(Owner))
      return false;

   Template->Clear();

   NymGenCfgNowDlg = new TNymGenCfgNowDlg(Owner);
   NymGenCfgNowDlg->Caption = " Create Nym Message";
   NymGenCfgNowDlg->Preview->Show();

   Global->DB->GetTemplates(NymGenCfgNowDlg->TempList->Items);
   AnsiString name = Global->DB->GetIni(LastNymCfgTemplate, "nym-config");

   int idx = NymGenCfgNowDlg->TempList->Items->IndexOf(name);
   if (idx < 0)
   {
      name = "Anonymous Reply";
   }

   idx = NymGenCfgNowDlg->TempList->Items->IndexOf(name);
   if (idx >= 0)
   {
      NymGenCfgNowDlg->TempList->Perform(LB_SETTOPINDEX, idx, NULL);
      NymGenCfgNowDlg->TempList->Selected[idx] = true;
   }

   NymGenCfgNowDlg->ShowModal();
   bool ok = NymGenCfgNowDlg->ModalResult == mrOk;
   if (ok)
   {
      idx = NymGenCfgNowDlg->TempList->ItemIndex;
      name = NymGenCfgNowDlg->TempList->Items->Strings[idx];
      Global->DB->GetTemplate(name, Template);

      Preview = NymGenCfgNowDlg->Preview->Checked;
      Global->DB->PutIni(LastNymCfgTemplate, name);
   }

   delete NymGenCfgNowDlg;

   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall GenFromNymMessage(TForm *Owner, TStrings *Template)
{
   if (SecureModeMsg(Owner))
      return false;

   Template->Clear();

   NymGenCfgNowDlg = new TNymGenCfgNowDlg(Owner);
   NymGenCfgNowDlg->Caption = " Create Message From Nym";
   NymGenCfgNowDlg->Preview->Hide();
   NymGenCfgNowDlg->Label2->Caption = "&Select a template";
   NymGenCfgNowDlg->Label1->Caption =
    "This function will create a message, where a specific nym is the "
    "sender, using the selected template.";

   Global->DB->GetTemplates(NymGenCfgNowDlg->TempList->Items);

   NymGenCfgNowDlg->ShowModal();
   bool ok = NymGenCfgNowDlg->ModalResult == mrOk;
   if (ok)
   {
      int idx = NymGenCfgNowDlg->TempList->ItemIndex;
      AnsiString name = NymGenCfgNowDlg->TempList->Items->Strings[idx];
      Global->DB->GetTemplate(name, Template);
   }

   delete NymGenCfgNowDlg;

   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall GenNymDeleteMessage(TForm *Owner, TStrings *Template)
{
   if (SecureModeMsg(Owner))
      return false;

   Template->Clear();

   NymGenCfgNowDlg = new TNymGenCfgNowDlg(Owner);
   NymGenCfgNowDlg->Caption = " Delete Nym Message";
   NymGenCfgNowDlg->Preview->Hide();

   Global->DB->GetTemplates(NymGenCfgNowDlg->TempList->Items);
   AnsiString name = Global->DB->GetIni(LastNymCfgTemplate, "nym-config");

   int idx = NymGenCfgNowDlg->TempList->Items->IndexOf(name);
   if (idx < 0)
   {
      name = "Anonymous Reply";
   }

   idx = NymGenCfgNowDlg->TempList->Items->IndexOf(name);
   if (idx >= 0)
   {
      NymGenCfgNowDlg->TempList->Perform(LB_SETTOPINDEX, idx, NULL);
      NymGenCfgNowDlg->TempList->Selected[idx] = true;
   }

   NymGenCfgNowDlg->ShowModal();
   bool ok = NymGenCfgNowDlg->ModalResult == mrOk;
   if (ok)
   {
      idx = NymGenCfgNowDlg->TempList->ItemIndex;
      name = NymGenCfgNowDlg->TempList->Items->Strings[idx];
      Global->DB->GetTemplate(name, Template);

    //Preview = NymGenCfgNowDlg->Preview->Checked;
      Global->DB->PutIni(LastNymCfgTemplate, name);
   }

   delete NymGenCfgNowDlg;

   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall GenNymReplayMessage(TForm *Owner, TStrings *Template)
{
   if (SecureModeMsg(Owner))
      return false;

   Template->Clear();

   NymGenCfgNowDlg = new TNymGenCfgNowDlg(Owner);
   NymGenCfgNowDlg->Caption = " Replay Nym Message";
   NymGenCfgNowDlg->Preview->Hide();

   Global->DB->GetTemplates(NymGenCfgNowDlg->TempList->Items);
   AnsiString name = Global->DB->GetIni(LastNymCfgTemplate, "nym-config");

   int idx = NymGenCfgNowDlg->TempList->Items->IndexOf(name);
   if (idx < 0)
   {
      name = "Anonymous Reply";
   }

   idx = NymGenCfgNowDlg->TempList->Items->IndexOf(name);
   if (idx >= 0)
   {
      NymGenCfgNowDlg->TempList->Perform(LB_SETTOPINDEX, idx, NULL);
      NymGenCfgNowDlg->TempList->Selected[idx] = true;
   }

   NymGenCfgNowDlg->ShowModal();
   bool ok = NymGenCfgNowDlg->ModalResult == mrOk;
   if (ok)
   {
      idx = NymGenCfgNowDlg->TempList->ItemIndex;
      name = NymGenCfgNowDlg->TempList->Items->Strings[idx];
      Global->DB->GetTemplate(name, Template);

    //Preview = NymGenCfgNowDlg->Preview->Checked;
      Global->DB->PutIni(LastNymCfgTemplate, name);
   }

   delete NymGenCfgNowDlg;

   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNymGenCfgNowDlg::TNymGenCfgNowDlg(TComponent* Owner)
        : TForm(Owner)
{
   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, TempList->Font, NULL);
}
//---------------------------------------------------------------------------

void __fastcall TNymGenCfgNowDlg::FormCloseQuery(TObject *Sender,
   bool &CanClose)
{
   if (ModalResult == mrOk && TempList->ItemIndex < 0)
   {
      MsgBox(this,
         "You need to select a template or click Cancel.",
          MT_INFO, MB_OK);
      CanClose = false;
      return;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymGenCfgNowDlg::TempListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------


