//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "NymGetTmplDlgs.h"
#include "QSDBs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymGetTmplDlg *NymGetTmplDlg;
//---------------------------------------------------------------------------

bool __fastcall GetNymConfigTemplate(TComponent* Owner, TStrings *Template)
{
   Template->Clear();
   TStringList *templates = new TStringList();
   Global->DB->GetTemplates(templates);

   if (templates->IndexOf("nym-config") >= 0)
   {
      Global->DB->GetTemplate("nym-config", Template);
      delete templates;
      return true;
   }

   NymGetTmplDlg = new TNymGetTmplDlg(Owner);
   NymGetTmplDlg->TemplateList->Items->AddStrings(templates);

   int t = NymGetTmplDlg->TemplateList->Items->IndexOf("Anonymous Reply");
   if (t >= 0)
   {
      NymGetTmplDlg->TemplateList->ItemIndex = t;
      NymGetTmplDlg->OkBtn->Enabled = true;
   }

   NymGetTmplDlg->ShowModal();

   bool ok = NymGetTmplDlg->ModalResult == mrOk;
   if (ok)
   {
      int x = NymGetTmplDlg->TemplateList->ItemIndex;
      AnsiString tmpl = NymGetTmplDlg->TemplateList->Items->Strings[x];
      Global->DB->GetTemplate(tmpl, Template);
   }

   delete NymGetTmplDlg;
   delete templates;

   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNymGetTmplDlg::TNymGetTmplDlg(TComponent* Owner)
        : TForm(Owner)
{
   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, TemplateList->Font, NULL);
   TemplateList->Color = color;
}
//---------------------------------------------------------------------------

void __fastcall TNymGetTmplDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk && TemplateList->ItemIndex == -1)
   {
      MsgBox(this, "You need to select a template or click Cancel.", MT_INFO, MB_OK);
      CanClose = false;
      return;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymGetTmplDlg::TemplateListDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TNymGetTmplDlg::TemplateListClick(TObject *Sender)
{
   OkBtn->Enabled = true;
}
//---------------------------------------------------------------------------
