//---------------------------------------------------------------------------
#ifndef NymRemEncChainDlgsH
#define NymRemEncChainDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
//#include "explbtn.hpp"
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall EditRemixEncryptChain(TForm *Owner, const AnsiString &Title,
   AnsiString &Chain);

class TNymRemEncChainDlg : public TForm
{
__published:	// IDE-managed Components
        TListBox *RemailerList;
        TBitBtn *CopyBtn;
        TListBox *Chain;
        TButton *OkBtn;
        TButton *CancelBtn;
        TLabel *Label7;
        TButton *HelpBtn;
        TBevel *Bevel1;
        TComboBox *RemailerBox;
        TSpeedButton *BrokeBtn;
        TSpeedButton *LegendBtn;
        TSpeedButton *DelRemBtn;
        TSpeedButton *CapBtn;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall CopyBtnClick(TObject *Sender);
        void __fastcall DelRemBtnClick(TObject *Sender);
        void __fastcall LegendBtnClick(TObject *Sender);
        void __fastcall RemailerListClick(TObject *Sender);
        void __fastcall RemailerListDrawItem(TWinControl *Control, int Index,
           TRect &Rect, TOwnerDrawState State);
        void __fastcall ChainClick(TObject *Sender);
        void __fastcall BrokeBtnClick(TObject *Sender);
        void __fastcall CapBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
       AnsiString chain;
       TStringList *rlist, *brokenchains, *capstrings;
       bool emailaddress, postdirect;
        __fastcall TNymRemEncChainDlg(TComponent* Owner);
        __fastcall virtual ~TNymRemEncChainDlg();

        void __fastcall LoadRemailers(const AnsiString &delremname);
        bool __fastcall RemailerInChain(const AnsiString &Remailer);
        void __fastcall RemailerListClear();
        void __fastcall LoadRemailersAll();
        void __fastcall ChainClear();
        int  __fastcall ChainLength();
        AnsiString __fastcall LastInChain();

        bool __fastcall HasCap(const AnsiString &Remailer, const AnsiString &Cap);
        AnsiString __fastcall GetCaps(const AnsiString &Remailer);
        AnsiString __fastcall GetCurrentCaps();
        int __fastcall UpDayCount(const AnsiString &Remailer);

        AnsiString __fastcall FixBrokenLine(AnsiString &line, int p);
        void __fastcall GetRemailersBeforeAndAfter(AnsiString &RemBefore, AnsiString &RemAfter);
        bool __fastcall RemailerPrecedesOrFollowsSelf(const AnsiString &Remailer,
           const AnsiString &RemBefore, const AnsiString &RemAfter);
        AnsiString __fastcall GetRemailerAt(int Position);
        bool __fastcall RemailerIsBroken(const AnsiString &remailer, const AnsiString &rembefore,
           const AnsiString &remafter, int &X);
        bool __fastcall IsBroken(const AnsiString &Remailer1, const AnsiString &Remailer2);

        void __fastcall GetBrokenCpunkChains(TStrings *Rlist, TStrings *Broken);
        void __fastcall GetCapStrings(TStrings *Rlist, TStrings *CapStrings);
};
//---------------------------------------------------------------------------
extern TNymRemEncChainDlg *NymRemEncChainDlg;
//---------------------------------------------------------------------------
#endif
