//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "RBEditDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRBEditDlg *RBEditDlg;
//---------------------------------------------------------------------------

__fastcall RunReplyBlockEditor(TComponent* Owner, const AnsiString &Nym,
   TStrings *ReplyBlock)
{
   RBEditDlg = new TRBEditDlg(Owner);
   RBEditDlg->ReplyBlock = ReplyBlock;
   RBEditDlg->Nym = Nym;

   RBEditDlg->ShowModal();
   bool ok = RBEditDlg->ModalResult == mrOk;
   delete RBEditDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TRBEditDlg::TRBEditDlg(TComponent* Owner)
        : TForm(Owner)
{
   rlist = new TStringList();
   AnsiString rlisttxt = MixDir() + "rlist.txt";
   if (FileExists(rlisttxt))
      rlist->LoadFromFile(rlisttxt);

   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, RBView->Font, NULL);
   RBView->Color = color;
}
//---------------------------------------------------------------------------

__fastcall TRBEditDlg::~TRBEditDlg()
{
   delete rlist;
}
//---------------------------------------------------------------------------

void __fastcall TRBEditDlg::FormShow(TObject *)
{
   AnsiString line;
   TTreeNode *cnode;
   assert(ReplyBlock->Count > 0);

   RBNode = RBView->Items->AddChild(NULL, ReplyBlock->Strings[0]);
   for (int i = 1; i < ReplyBlock->Count; i++)
   {
      line = ReplyBlock->Strings[i];
      switch (line.Length() - line.Trim().Length())
      {
         case 1: cnode = RBView->Items->AddChild(RBNode, line.Trim()); break;
         case 2: RBView->Items->AddChild(cnode, line.Trim()); break;
      }
   }

   RBView->FullExpand();
   ReplyBlock->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TRBEditDlg::RBViewClick(TObject *)
{
   ModBtn->Enabled =
      RBView->Selected && RBView->Selected->Level == 1 &&
      RBView->Selected != RBNode->Item[RBNode->Count - 1];
   DelBtn->Enabled = ModBtn->Enabled;
}
//---------------------------------------------------------------------------

