//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "PGPFixDirDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPGPFixDirDlg *PGPFixDirDlg;
//---------------------------------------------------------------------------

bool __fastcall FixKeyringDirectoryProblem(TForm *Owner, AnsiString &Pubring, AnsiString &Secring)
{
   AnsiString pubring, pubpath, secring, secpath;
   pubring = ExtractFileName(Pubring);
   pubpath = ExtractFilePath(Pubring);
   secring = ExtractFileName(Secring);
   secpath = ExtractFilePath(Secring);

   PGPFixDirDlg = new TPGPFixDirDlg(Owner);
   PGPFixDirDlg->CopyPub2Sec->Caption = "Copy " + pubring + " to: " + secpath;
   PGPFixDirDlg->CopySec2Pub->Caption = "Copy " + secring + " to: " + pubpath;

   PGPFixDirDlg->ShowModal();

   bool ok = PGPFixDirDlg->ModalResult == mrOk;
   if (ok)
   {
      TMemoryStream *ms = new TMemoryStream();
      if (PGPFixDirDlg->CopyPub2Sec->Checked)
      {
         if (FileExists(secpath + pubring))
         {
            if (MsgBox(Owner,
               "The file " + secpath + pubring + " exists! Overwrite it?",
                MT_CONFIRM, MB_OKCANCEL) == IDCANCEL)
            {
               delete ms;
               delete PGPFixDirDlg;
               return false;
            }
         }
         ms->LoadFromFile(Pubring);
         ms->SaveToFile(secpath + pubring);
      }
      else
      {
         if (FileExists(pubpath + secring))
         {
            if (MsgBox(Owner,
               "The file " + pubpath + secring + " exists! Overwrite it?",
                MT_CONFIRM, MB_OKCANCEL) == IDCANCEL)
            {
               delete ms;
               delete PGPFixDirDlg;
               return false;
            }
         }
         ms->LoadFromFile(Secring);
         ms->SaveToFile(pubpath + secring);
      }
      delete ms;
   }
   delete PGPFixDirDlg;

   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPGPFixDirDlg::TPGPFixDirDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
