//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "global2.h"
#include "pgpsdk.h"
#include "pgpsdk8.h"
#include "pgpsdk6.h"

TPGPsdk *PGPsdk;
TPGPsdk *PGP = NULL;
AnsiString MixmasterDir;
unsigned int PreferredAlgo;
#pragma package(smart_init)
//---------------------------------------------------------------------------
// PGPsdk
//---------------------------------------------------------------------------

__fastcall TPGPsdk::TPGPsdk()
   : TObject()
{
}
//---------------------------------------------------------------------------

__fastcall TPGPsdk::TPGPsdk(TForm *owner, const AnsiString &qspubringpkr,
   const AnsiString &qssecringskr, const AnsiString &qsremringpkr)
   : TObject()
{
   Owner = owner;
   pubringpkr = qspubringpkr;
   secringskr = qssecringskr;
   remringpkr = qsremringpkr;

   headers = new TStringList();
}
//---------------------------------------------------------------------------

__fastcall TPGPsdk::~TPGPsdk()
{
   delete headers;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPGPsdk::GetLastErrorStr()
{
   return "No Error";
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::CEncryptMessage(TStrings *Message,
   const AnsiString &Passphrase)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::ExportDefaultKeys(TStrings *exports)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::ExportDefaultKeysFast(TStrings *exports)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::CheckPGP6NeedsUpdate(TControl *ForHourGlass)
{
   // TODO 0: PGP6AUTOUPDATE
   //if (!PGP6AUTOUPDATE) return false;

   int QDKpub = FileAge(mainpubringpkr);  // QDK = sdk keyrings
   int PGPpub = FileAge(pubringpkr);    // quicksilver keyrings
   int QDKsec = FileAge(mainsecringskr);
   int PGPsec = FileAge(secringskr);
   if (QDKpub < 0 || QDKsec < 0)
      return false;

   if (PGPpub < 0 || PGPsec < 0 || QDKpub > PGPpub || QDKsec >PGPsec)
   {
      UpdateQSKeyrings(ForHourGlass);
      return true;
   }

   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::UpdateQSKeyrings(TControl *ForHourGlass)
{
   return false;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPGPsdk::MessageDecryptVerifyLine(bool first, int decs,
   int sigs)
{
   AnsiString line = "*** " + AnsiString(first ? "BEGIN" : "END") + " PGP ";
   if (decs > 0) line += "DECRYPTED";
   if (decs > 0 && sigs > 0) line += "/";
   if (sigs > 0) line += "VERIFIED";
   line += " MESSAGE ***";
   return line;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::VerifyClearSigned(TStrings *Message)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::DecryptMessage(TStrings *Message, char *Passphrase,
   TStrings *DecKeyIds, bool recurse)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::SignMessage(TStrings *Message, char *SignKeyid,
   char *Passphrase)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::EncryptMessage(TStrings *Message, TStrings *KeyIds)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::EncryptToUserID(const AnsiString &Pubring,
   const AnsiString &UserID, TStrings *theText)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::EncryptToUserIDs(const AnsiString &Pubring,
   TStrings *UserIDs, TStrings *theText)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::EncryptTo(const AnsiString &Pubring, const AnsiString &KeyID,
   TStrings *Text)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::EncryptTo(const AnsiString &Pubring, TStrings *KeyIDs,
   TStrings *Text)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::EncryptSignMessage(TStrings *Message,
   TStrings *EncKeyIds, char *SigKeyId, char *Passphrase)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::GetKeys(const AnsiString &pubRing, const AnsiString &secRing,
   TStrings *Keys)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::GetKeys(const AnsiString &pubRing, TStrings *Keys)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::GetKeysLV(const AnsiString &pubRing, const AnsiString &secRing,
   TStrings *Keys)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::GetKeyLV(const AnsiString &pubring, const AnsiString &secring,
   const AnsiString &keyid, AnsiString &keydesc)
{
   return false;
}
//---------------------------------------------------------------------------

void __fastcall TPGPsdk::PopHeaders(TStrings *message)
{
   headers->Clear();
   while (message->Count > 0)
   {
      AnsiString hdr = message->Strings[0];
      message->Delete(0);
      headers->Add(hdr);

      if (hdr.IsEmpty())
         break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPGPsdk::PushHeaders(TStrings *message)
{
   for (int i = 0; i < headers->Count; i++)
      message->Insert(i, headers->Strings[i]);
   headers->Clear();
}
//---------------------------------------------------------------------------

int __fastcall TPGPsdk::IdNo()
{
   return 0;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPGPsdk::GetKeyID(const AnsiString &Pubring, const AnsiString &UserID)
{
   return "";
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::ExportKeys(const AnsiString Pubring, const AnsiString Secring,
   TStrings *KeyIDS, bool IncludePrivates, TStrings *Exports)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::ExportKey(const AnsiString Pubring, const AnsiString Secring,
   AnsiString KeyID, bool IncludePrivate, TStrings *Export)
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::RandomMouseMoved()
{
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall TPGPsdk::GetRandomBytes(void *dataBuf, int size)
{
   return false;
}
//---------------------------------------------------------------------------
// GetEncryptKey
//---------------------------------------------------------------------------

AnsiString __fastcall Base64EncodeLine(char *buffer, int length)
{
   const char Base64Chars[] =
   {
    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
    'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
    'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
    'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '='
   };

   char DataIn[3];
   char DataOut[81];
   AnsiString encodedline;
   int i, Count = 0, BytesRd, InBytes = sizeof(DataIn);

   TMemoryStream *f = new TMemoryStream();
   f->Write(buffer, length);
   f->Position = 0;

   while (true)
   {
      BytesRd = f->Read(DataIn, InBytes);
      for (i = 1; i < 4; i++)
         DataOut[Count + i] = 0x40;

      DataOut[Count]   = char((DataIn[0] & 0xFC) >> 2);
      DataOut[Count + 1] = char((DataIn[0] & 0x03) << 4);
      if (BytesRd > 1)
      {
         DataOut[Count + 1] += char((DataIn[1] & 0xF0) >> 4);
         DataOut[Count + 2]  = char((DataIn[1] & 0x0F) << 2);
         if (BytesRd > 2)
         {
            DataOut[Count + 2] += char((DataIn[2] & 0xC0) >> 6);
            DataOut[Count + 3]  =  char(DataIn[2] & 0x3F);
         }
      }

      for (i = 0; i < 4; i++)
         DataOut[Count + i] = byte(Base64Chars[DataOut[Count + i]]);

      Count += 4;
      if (Count < 60 && BytesRd == InBytes)
         continue;

      DataOut[Count] = '\0';

      encodedline += AnsiString(&DataOut[0]);

      if (BytesRd < InBytes)
         break;

      Count = 0;
   }

   delete f;
   return encodedline;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPGPsdk::GetEncryptKey(int beforeEncodeLength)
{
   char *buffer = new char[beforeEncodeLength];

   if (!GetRandomBytes(buffer, beforeEncodeLength))
   {
      MessageBox(Application->MainForm->Handle,
         "I have encountered a problem in creating your encryption key.   \n"
         "PGP was not able to fill my request for crypto quality random    \n"
         "bytes to use for your key. Don't use the keys generated now.   \n"
         "Close this dialog and in the QSnym main window wave your mouse   \n"
         "around for a couple minutes and this will increase PGP's \n"
         "entropy level. Then try again.\n\n"
         "This is unexpected. If you have a minute please drop me a note at:  \n"
         "quicksilver@quicksilvermail.net",
         "Information", MB_ICONINFORMATION | MB_OK);
      delete [] buffer;

      return "PGPError_OutOfEntropy";
   }

   AnsiString base64key = Base64EncodeLine(buffer, beforeEncodeLength);
   int len = base64key.Length();
   assert(len > 0);

   while (base64key[len] == '=')
   {
      base64key.SetLength(--len);
   }

   delete [] buffer;

   return base64key;
}
//---------------------------------------------------------------------------





