//---------------------------------------------------------------------------
#ifndef PGPsdk8H
#define PGPsdk8H

#include "PgpSdk.h"
//---------------------------------------------------------------------------

class TPGPsdk8 : public TPGPsdk
{
public:
   __fastcall virtual TPGPsdk8(TForm *owner, unsigned options);
   __fastcall virtual TPGPsdk8(TForm *Owner, const AnsiString &Pubring, const AnsiString &Secring,
      const AnsiString &Remring);
   __fastcall virtual ~TPGPsdk8();
   // cipher
   bool __fastcall VerifyClearSigned(TStrings *SignedText);
   bool __fastcall DecryptMessage(TStrings *Message, char *Passphrase, TStrings *DecKeyIds, bool recurse);
   //bool __fastcall SignMessage(TStrings *Message, char *keyid, char *Passphrase);
   //bool __fastcall EncryptMessage(TStrings *Message, TStrings *KeyIds);
   //bool __fastcall EncryptSignMessage(TStrings *Message, TStrings *EncKeyIds, char *SignKeyid, char *Passphrase);
   // new cipher
   bool __fastcall EncryptToUserID(const AnsiString &Pubring, const AnsiString &UserID, TStrings *Text);
   bool __fastcall EncryptToUserIDs(const AnsiString &Pubring, TStrings *UserIDs, TStrings *theText);
   bool __fastcall EncryptTo(const AnsiString &Pubring, const AnsiString &KeyID, TStrings *Text);
   bool __fastcall EncryptTo(const AnsiString &Pubring, TStrings *KeyIDs, TStrings *Text);
   bool __fastcall EncryptTo(const AnsiString &Passphrase, TStrings *Text);
   // keyring key info functions
   bool __fastcall GetKeysLV(const AnsiString &pubring, const AnsiString &secring, TStrings *Keys);
   bool __fastcall GetKeyLV(const AnsiString &pubring, const AnsiString &secring,
      const AnsiString &keyid, AnsiString &keydesc);
   bool __fastcall GetKeys(const AnsiString &Pubring, const AnsiString &Secring, TStrings *Keys);
   bool __fastcall GetKeys(const AnsiString &Pubring, TStrings *Keys);
   AnsiString __fastcall GetKeyID(const AnsiString &Pubring, const AnsiString &UserID);
   bool __fastcall ExportKeys(const AnsiString Pubring, const AnsiString Secring, TStrings *KeyIDS,
      bool IncludePrivates, TStrings *Exports);
   bool __fastcall ExportKey(const AnsiString Pubring, const AnsiString Secring, AnsiString KeyID,
      bool IncludePrivate, TStrings *Export);
   // support functions
   bool __fastcall UpdateQSKeyrings(TControl *ForHourGlass);
   bool __fastcall ExportDefaultKeysFast(TStrings *exports);
   bool __fastcall ExportDefaultKeys(TStrings *exports);
   // entropy
   bool __fastcall RandomMouseMoved();
   bool __fastcall GetRandomBytes(void *dataBuf, int size);
   // utility
   AnsiString __fastcall GetLastErrorStr();
   bool __fastcall LoadDefaultPrefs();
   int  __fastcall IdNo();

   AnsiString pgpprefstxt;
   TStringList *prefs;
};

PACKAGE TPGPsdk* __fastcall PGPInitV8(TForm *Owner, const AnsiString &pubring,
   const AnsiString &secring, const AnsiString &remring);

//---------------------------------------------------------------------------
#endif
