//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "PrintProxyDlgs.h"
#include "PrintDlgs2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPrintProxyDlg *PrintProxyDlg;
//---------------------------------------------------------------------------

bool __fastcall OpenPrinterDialog(TForm *Owner, TListView *ListView)
{
    bool hassel = ListView->Selected != NULL;
    PrintProxyDlg = new TPrintProxyDlg(Owner);
    PrintProxyDlg->Font->Assign(Owner->Font);
    PrintProxyDlg->AllBox->Checked = !hassel;
    PrintProxyDlg->SelBox->Enabled = hassel;
    PrintProxyDlg->SelBox->Checked = hassel;
    PrintProxyDlg->ListView = ListView;

    PrintProxyDlg->ShowModal();

    bool ok = PrintProxyDlg->ModalResult == mrOk;
    delete PrintProxyDlg;

    return ok;
}

//---------------------------------------------------------------------------

__fastcall TPrintProxyDlg::TPrintProxyDlg(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPrintProxyDlg::IndexStr(TListItem *item)
{
   return item->SubItems->Strings[item->SubItems->Count - 1];
}
//---------------------------------------------------------------------------

void __fastcall TPrintProxyDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      if (SecureModeMsg(this))
      {
         CanClose = false;
         return;
      }
      
      AnsiString socks;
      TStringList *rpt = new TStringList();
      TStringList *prxy = new TStringList();

      for (int i = 0; i < ListView->Items->Count; i++)
      {
         TListItem *item = ListView->Items->Item[i];
         if (AllBox->Checked || item->Selected)
         {
            Global->DB->GetProxy(IndexStr(item), prxy);
            rpt->Add(prxy->Values["name"]);
            rpt->Add("Host: " + prxy->Values["host"]);
            if (prxy->Values["auth"] == "1")
            {
               rpt->Add("User ID: " + prxy->Values["userid"]);
               if (PasswdsBox->Checked)
                  rpt->Add("Password: " + prxy->Values["password"]);
            }
            socks = prxy->Values["socksver"].LowerCase();
            if (!socks.IsEmpty())
               rpt->Add("Socks: " + prxy->Values["socksver"]);
            if (prxy->Values["http"] == "1")
               rpt->Add("HTTP: " + prxy->Values["httpport"]);
            if (prxy->Values["POP3"] == "1")
               rpt->Add("POP3: " + prxy->Values["pop3port"]);
            if (prxy->Values["smtp"] == "1")
               rpt->Add("SMTP: " + prxy->Values["smtpport"]);
            if (prxy->Values["nntp"] == "1")
               rpt->Add("NNTP: " + prxy->Values["nntpport"]);
            if (prxy->Values["ftp"] == "1")
               rpt->Add("FTP: " + prxy->Values["ftpport"]);
            rpt->Add("");
         }
      }

      PrintDocument(this, "QuickSilver Proxy List", rpt, ListView->Font);
      delete prxy;
      delete rpt;
   }
}
//---------------------------------------------------------------------------

