/*
*  AboutDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <inifiles.hpp>

#include "AboutDlgs.h"
#include "Global.h"
#include "qs1\QSver.h"
#include "pop3mail.h"
#include "pgpmail.h"
#include "newsmail.h"
#include "nymmail.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAboutDlg *AboutDlg;
//---------------------------------------------------------------------------
void __fastcall ShowAboutBox(TForm *owner, int entropy)
{
   int spc = 10;
   AnsiString space, ver, libname, version;
   AboutDlg = new TAboutDlg(owner);
   CenterDialog(AboutDlg,owner);
   AboutDlg->Caption = "About";
   AboutDlg->Appname->Caption = AppName.Trim()+" "+ReleaseVersion.Trim();

   AnsiString copyright = "Copyright  1999- by Richard Christman\nAll Rights Reserved";
   copyright.Insert(FormatDateTime("yyyy", Now()), 18);

   AboutDlg->Copyright->Caption = copyright;
   AboutDlg->PluginList->Height = 0;
   AboutDlg->PluginList->Top = AboutDlg->Appname->Top + AboutDlg->Appname->Height;// + 5;
   AboutDlg->PluginList->Clear();

   if (HasPop3())
   {
      AnsiString libname = GetParam(0,GetPop3AppName()," ");
      libname += space.StringOfChar(' ',spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+AnsiString(GetPop3Version()));
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
   }

   if (HasPgp() && !FileExists(AppDir + "qspgp.bpl"))
   {
      AnsiString libname = GetParam(0,GetPgpLibName()," ");
      libname += space.StringOfChar(' ',spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+AnsiString(GetPgpLibVersion()));
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
   }

   if (HasNyms() && !FileExists(AppDir + "qsnym.exe"))
   {
      AnsiString libname = GetParam(0,GetNymLibName()," ");
      libname += space.StringOfChar(' ',spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+AnsiString(GetNymLibVersion()));
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
   }

   if (HasNews())
   {
      AnsiString libname = GetParam(0,GetNewsLibName()," ");
      libname += space.StringOfChar(' ',spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+GetNewsLibVersion());
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
   }

   if (FileExists(AppDir + "qsstats.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsstats.ini");
      version = ini->ReadString(StatsIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      libname = "QSstats";
      libname += space.StringOfChar(' ', spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+version);
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
      delete ini;
   }

   if (FileExists(AppDir + "qspgp.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qspgp.ini");
      version = ini->ReadString(PgpIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      libname = "QSpgp";
      libname += space.StringOfChar(' ', spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+version);
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
      delete ini;
   }

   if (FileExists(AppDir + "qsnym.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsnym.ini");
      version = ini->ReadString(NymIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      libname = "QSnym";
      libname += space.StringOfChar(' ', spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+version);
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
      delete ini;
   }

   if (FileExists(AppDir + "qsproxy.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsproxy.ini");
      version = ini->ReadString(ProxyIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      libname = "QSproxy";
      libname += space.StringOfChar(' ', spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+version);
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
      delete ini;
   }

   if (FileExists(AppDir + "qsreports.exe"))
   {
      TIniFile *ini = new TIniFile(AppDir + "qsreports.ini");
      version = ini->ReadString(ReportsIni, "version", "-----");
      if (version == "-----")
         version = ini->ReadString("main", "version", "-----");
      libname = "QSreports";
      libname += space.StringOfChar(' ', spc-libname.Length());
      AboutDlg->PluginList->Lines->Add(libname+version);
      AboutDlg->PluginList->Height += 16;
      AboutDlg->Copyright->Top += 16;
      AboutDlg->OkBtn->Top += 16;
      AboutDlg->Height += 16;
      AboutDlg->Entropy->Top += 16;
      delete ini;
   }

   AboutDlg->Copyright->Top += 3;
   AboutDlg->OkBtn->Top += 3;
   AboutDlg->Height += 3;
   AboutDlg->Entropy->Top += 3;
   AboutDlg->Entropy->Caption = "Entropy: " + IntToStr(entropy) + "%";

   MyBeep(MB_OK);
   AboutDlg->ShowModal();
   delete AboutDlg;
}
//---------------------------------------------------------------------------
__fastcall TAboutDlg::TAboutDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
