/*
*  BarredRemsDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BarredRemsDlgs.h"
#include "CpkKeyWins2.h"
#include "mixmaster.h"
#include "HelpDlgs.h"
//#include "MsgBoxDlgs.h"
#include "FileMan.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBarredRemsDlg *BarredRemsDlg;
//---------------------------------------------------------------------------

bool __fastcall CheckDeleteBarredMixmasterKeys()
{
   bool bar=false;
   TStringList *mixkeys = new TStringList();
   if (FileExists(mringtxt)) mixkeys->LoadFromFile(mringtxt);
   if (CheckDeleteBarredMixmasterKeys(mixkeys))
   {
      mixkeys->SaveToFile(mringtxt);
      bar = true;
   }
   delete mixkeys;
   return bar;
}
//---------------------------------------------------------------------------

bool __fastcall CheckDeleteBarredMixmasterKeys(TStrings *Keys)
{
   AnsiString line;
   bool modified=false;
   TStringList *bars = new TStringList();
   TStringList *last = new TStringList();
   bars->Sorted = true;

   if (FileExists(BarFile))
      bars->LoadFromFile(BarFile);

   bars->Sorted = false;
   //-- last bars --------------------------
   int i = 0; // gather last bars
   while (i < bars->Count)
   {
      AnsiString line = bars->Strings[i];
      if (GetToken(1, line, ",").Trim() == "last")
      {
         last->Add(GetToken(0, line, ","));
         bars->Delete(i);
      }
      else
         i++;
   }
   //-- end last bars -----------------------

   // make sure 'lcs' is barred -- doesn't support pasted headers
   if (bars->IndexOf(LCSremailer) < 0)
   {
      bars->Add(LCSremailer);
      PutAppData(BarredMixmaster, bars);
   }

   for (int b = 0; b < bars->Count; b++)
   {
      int k = 0; while (k < Keys->Count)
      {
         if (Keys->Strings[k].LowerCase().Pos(bars->Strings[b].LowerCase()) == 1)
         {
            bool gotkey = false;
            while (k < Keys->Count)
            {
               line = Keys->Strings[k]; Keys->Delete(k);
               if (line == "-----End Mix Key-----")
                  gotkey = true;
               if (line.IsEmpty() && gotkey)
                  break;
               modified = true;
            }
         }
         k++;
      }
   }

   // handle those barred only from last, mark as middleman
   for (int i = 0; i < last->Count; i++)
   {
      AnsiString remailer = GetToken(0, last->Strings[i], " ");
      for (int k = 0; k < Keys->Count; k++)
      {
         AnsiString line = Keys->Strings[k];
         if (GetToken(0, line, " ") == remailer && GetToken(4, line, " ").Pos("M") == 0)
         {
            AnsiString field, newline;
            int x = 0; while ((field = GetToken(x, line, " ")) != "")
            {
               if (x == 4)
                  field = "M" + field;

               newline += field + " ";

               x++;
            }
            Keys->Strings[k] = newline;
            modified = true;
            break;
         }
      }
   }

   CheckDeleteBarredMixmasterType2(bars, last);

   delete last;
   delete bars;
   return modified;
}
//---------------------------------------------------------------------------

/*bool __fastcall CheckDeleteBarredMixmasterKeys(TStrings *Keys)
{
   bool modified=false;
   AnsiString line;
   TStringList *bars = new TStringList();
   bars->Duplicates = dupIgnore;
   bars->Sorted = true;

   if (FileExists(BarFile))
      bars->LoadFromFile(BarFile);

   // make sure 'lcs' is barred -- doesn't support pasted headers
   if (bars->IndexOf("lcs") < 0)
   {
      bars->Add("lcs");
      bars->SaveToFile(BarFile);
   }

   for (int b = 0; b < bars->Count; b++)
   {
      int k = 0; while (k < Keys->Count)
      {

         if (Keys->Strings[k].LowerCase().Pos(bars->Strings[b].LowerCase() + " ") == 1)
         {
            bool gotkey = false;
            while (k < Keys->Count)
            {
               line = Keys->Strings[k]; Keys->Delete(k);
               if (line=="-----End Mix Key-----")
                  gotkey = true;
               if (line.IsEmpty() && gotkey)
                  break;
               modified = true;
            }
         }
         k++;
      }
   }
   CheckDeleteBarredMixmasterType2(bars);

   delete bars;
   return modified;
}*/
//---------------------------------------------------------------------------

bool __fastcall CheckDeleteBarredMixmasterType2(TStrings *bars, TStrings *Last)
{
   AnsiString line;
   bool modified = false;
   TStringList *Type2 = new TStringList();

   if (FileExists(mtyp2txt))
      Type2->LoadFromFile(mtyp2txt);

   for (int b = 0; b < bars->Count; b++)
   {
      int t = 0; while (t < Type2->Count)
      {
         if (Type2->Strings[t].LowerCase().Pos(bars->Strings[b].LowerCase()) > 0)
         {
            Type2->Delete(t);
            modified = true;
            break;
         }
         t++;
      }
   }

   // handle those barred only from last, mark as middleman
   for (int i = 0; i < Last->Count; i++)
   {
      AnsiString remailer = GetToken(0, Last->Strings[i], " ");
      for (int t = 0; t < Type2->Count; t++)
      {
         AnsiString line = Type2->Strings[t];

         if (GetToken(0, line, " ") == remailer && GetToken(4, line, " ").Pos("M") == 0)
         {
            AnsiString field, newline;

            int x = 0; while ((field = GetToken(x, line, " ")) != "")
            {
               if (x == 4)
                  field = "M" + field;

               newline += field + " ";

               x++;
            }

            Type2->Strings[t] = newline.TrimRight();
            modified = true;
            break;
         }
      }
   }

   if (modified)
      Type2->SaveToFile(mtyp2txt);

   delete Type2;
   return modified;
}
//---------------------------------------------------------------------------

/*bool __fastcall CheckDeleteBarredMixmasterType2(TStrings *bars)
{
   AnsiString line;
   bool modified=false;
   TStringList *Type2 = new TStringList();
   if (FileExists(mtyp2txt)) Type2->LoadFromFile(mtyp2txt);
   for (int b = 0; b < bars->Count; b++)
   {
      int t = 0; while (t < Type2->Count)
      {
         if (Type2->Strings[t].LowerCase().Pos(bars->Strings[b].LowerCase() + " ") == 1)
         {
            Type2->Delete(t);
            modified = true;
            break;
         }
         t++;
      }
   }
   if (modified) Type2->SaveToFile(mtyp2txt);
   delete Type2;
   return modified;
}*/
//---------------------------------------------------------------------------

bool __fastcall CheckDeleteBarredCypherpunkKeys()
{
   bool ok=false;
   TStringList *keys = new TStringList();
   if (FileExists(cringtxt))
       keys->LoadFromFile(cringtxt);

   if (CheckDeleteBarredCypherpunkKeys(keys))
   {
     keys->SaveToFile(cringtxt);
     ok = true;
   }

   if (FileExists(clisttxt))
   {
      TStringList *stats = new TStringList();
      stats->LoadFromFile(clisttxt);
      BarCpunkRemailersLast(stats);
      stats->SaveToFile(clisttxt);
      delete stats;
   }

   delete keys;
   return ok;
}
//---------------------------------------------------------------------------

void __fastcall BarCpunkRemailersLast(TStrings *stats)
{
   TStringList *last = new TStringList();
   TStringList *bars = new TStringList();

   if (FileExists(BarFile))
      bars->LoadFromFile(BarFile);

   for (int i = 0; i < bars->Count; i++)
   {
      AnsiString line = bars->Strings[i];

      if (line.Pos(",last") > 0)
         last->Add(GetToken(0, line, ","));
   }

   int l = -1; while (++l < last->Count)
   {
      AnsiString remailer = last->Strings[l];

      for (int i = 0; i < stats->Count; i++)
      {
         AnsiString line = stats->Strings[i];

         if (line.Pos("$remailer{") == 1 &&  GetToken(1, line, "\"") == remailer)
         {
            if (line.Pos(" middle") == 0)
            {
               int p = line.Pos(">");
               line.Insert(" middle", p + 1);
               stats->Strings[i] = line;
            }
            break;
         }
      }
   }

   delete bars;
   delete last;
}
//---------------------------------------------------------------------------

bool __fastcall CheckDeleteBarredCypherpunkKeys(TStrings *Keys)
{
   AnsiString bar;
   bool modified=false; //int p;
   TStringList *bars = new TStringList();
   TCpkKeyList2 *keys = new TCpkKeyList2(Keys);
   if (FileExists(BarFile))
      bars->LoadFromFile(BarFile);
   //GetAppData(bars,"BarredCypherpunk");

   int b = -1; while (++b < bars->Count)
   {
      bar = bars->Strings[b]; //if ((p=bar.Pos(" "))>0) bar[p] = ',';
      int k = 0; while(k < keys->Count)
      {
         if (keys->Strings[k].LowerCase().Pos(bar.LowerCase() + ",") == 1)
         {
            keys->DeleteKey(k);
            modified = true;
            continue;
         }
         k++;
      }
   }
   if (modified)
   {
      Keys->Clear();
      keys->SaveToStrings(Keys);
   }
   delete keys;
   delete bars;
   return modified;
}
//---------------------------------------------------------------------------
bool __fastcall EditBarredCypherpunkRemailers(TForm *Owner)
{
   BarredRemsDlg = new TBarredRemsDlg(Owner, "Cypherpunk");
   BarredRemsDlg->Label1->Caption = "&List remailers (short names only) you wish barred from use :";
   BarredRemsDlg->ShowModal();
   bool ok = BarredRemsDlg->ModalResult==mrOk;
   delete BarredRemsDlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall EditBarredMixmasterRemailers(TForm *Owner)
{
   BarredRemsDlg = new TBarredRemsDlg(Owner, "Mixmaster");
   BarredRemsDlg->Label1->Caption = "&List remailers (short name only) you wish barred from use :";
   BarredRemsDlg->ShowModal();
   bool ok = BarredRemsDlg->ModalResult==mrOk;
   delete BarredRemsDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TBarredRemsDlg::TBarredRemsDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TBarredRemsDlg::TBarredRemsDlg(TComponent* Owner, char *caption)
   : TForm(Owner)
{
   cap = caption;
   Memo1->Clear();
   CenterDialog(this,Owner);
   Caption = "Barred "+cap+" Remailers";

   TStringList *bars = new TStringList();
   if (FileExists(BarFile))
      bars->LoadFromFile(BarFile);
   //GetAppData(bars,"Barred"+cap);

   bars->Sorted = true;
   // make sure 'lcs' is barred -- doesn't support pasted headers
   if (!bars->Find("lcs", NULL))
      bars->Add("lcs");

   Memo1->Lines->AddStrings(bars);
   delete bars;

   Memo1->Modified = false;
   Memo1->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall TBarredRemsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Memo1->Modified)
   {
      if (ModalResult==mrCancel)
      {
         switch (MsgDlg(this,
            s("Your list of barred remailers is modified.\n")+
            s("Save your changes?"),s("Confirm"),
            MB_YESNOCANCEL))
         {
            case IDCANCEL:
               CanClose = false;
            case IDNO:
               return;
         }
      }

      TStringList *bars = new TStringList();
      bars->Duplicates = dupIgnore;
      bars->Sorted = true;

      bars->AddStrings(Memo1->Lines);
      if (!bars->Find("lcs", NULL))
      {
         MsgDlg(this,
            "I see you have removed 'lcs'.\n\n"
            "Sorry, this remailer cannot be reinstated. It uses an older version\n"
            "of mixmaster that does not support 'pasted' headers. QS uses pasted  \n"
            "headers to overcome the mixmaster 80 character maximum header\n"
            "length. This is the only remailer suffering this incompatibility.",
            "Information", MB_OK
         );
      }
      bars->SaveToFile(BarFile);
    //PutAppData("Barred"+cap, bars);
      delete bars;
   }
}
//---------------------------------------------------------------------------
void __fastcall TBarredRemsDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp2("Remailer_Barred Remailers","Barred Remailers","");
}
//---------------------------------------------------------------------------
