/*
*  DelKeyringBkupsDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "global.h"
#include "DelKeyringBkupsDlgs.h"
#include "dntaskdlgs.h"
#include "fileman.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TDelKeyringBkupsDlg *DelKeyringBkupsDlg;
AnsiString dlgmsg =
   "\nI see you have chosen to hide your QS personal PGP keyrings in the QS "
   "database when QS is shutting down. Some versions of PGP create backups of "
   "the keyrings whenever you use the sign or encrypt capabilities. It would "
   "not accomplish your purpose if these backups remain in the keyring directory. "
   "For that reason QS will delete any backups it finds. This has just been done. "
   "QS looks for files in this format:\n\n"
   "pubring-bak-1.pkr\n"
   "secring-bak-1.skr\n\n"
   "In your case, the base name will be whatever you have called your keyrings. "
   "Most likely it will be pubring/secring. The examples above show backup 1. "
   "There could be 4 or 5 or more. When QS deletes backups, It checks for backups "
   "1 through 6 and deletes any found. If there is a 6th backup, QS will continue with 6 and go until it "
   "encounters a backup that is not present. It will terminate the process.\n\n"
   "I want you to look at your keyring directory and see if there are any remaining "
   "backups. If you had, for example, backups 6, 7, 8 and 11, QS would stop checking "
   "at 9. For that reason you should look and delete any backups you find. This "
   "should only be required once, but you might want to have a look once in a while. "
   "Here are a couple more variations you may encounter:\n\n"
   "pubring.pkr.tmp\n"
   "pubring.pkr-bak-1.tmp\n\n"
   "Please use the button below to open and examine your keyring directory.";


//---------------------------------------------------------------------------

void __fastcall ExplainDelKeyringBackups(TForm *Owner, const AnsiString &KeyringDir)
{
   const AnsiString dontshowkey = "explaindelkeyringbkups";
   TStringList *dontshow = new TStringList();
   dontshow->Sorted = true;

   GetAppData(dontshow, APPDONTASKKEY);
   if (dontshow->Find(dontshowkey,NULL))
   {
      delete dontshow;
      return;
   }

   DelKeyringBkupsDlg = new TDelKeyringBkupsDlg(Owner);
   DelKeyringBkupsDlg->keyringdir = KeyringDir;
   DelKeyringBkupsDlg->ShowModal();
   if (DelKeyringBkupsDlg->DontShowBox->Checked)
   {
      dontshow->Add(dontshowkey);
      PutAppData(APPDONTASKKEY, dontshow);
   }

   delete DelKeyringBkupsDlg;
   delete dontshow;
}
//---------------------------------------------------------------------------

__fastcall TDelKeyringBkupsDlg::TDelKeyringBkupsDlg(TComponent* Owner)
        : TForm(Owner)
{
   CenterDialog(this, Owner);
   RichEdit1->Lines->Text = dlgmsg;
   SetEditRect(RichEdit1);
}
//---------------------------------------------------------------------------

void __fastcall TDelKeyringBkupsDlg::Button2Click(TObject *Sender)
{
   ExploreFolder(keyringdir);
}
//---------------------------------------------------------------------------
