/*
*  HashCashDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef HashCashDlgsH
#define HashCashDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall OpenHashCashManager(TForm *Owner);

class THashCashDlg : public TForm
{
__published:	// IDE-managed Components
        TListView *ListView;
        TButton *OkBtn;
        TButton *CancelBtn;
        TBevel *Bevel1;
        TButton *AddBtn;
        TButton *ModBtn;
        TButton *DelBtn;
        TButton *HelpBtn;
        void __fastcall AddBtnClick(TObject *Sender);
        void __fastcall ModBtnClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall ListViewClick(TObject *Sender);
        void __fastcall DelBtnClick(TObject *Sender);
        void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool modified;        
        __fastcall THashCashDlg(TComponent* Owner);
        void __fastcall Save();
};

// various hashcash functions used for addid hashcash to message
bool __fastcall AddHashCashToHeaders(TStrings *Message, const AnsiString &GateWayStr);
bool __fastcall hashcashrecipient(TStrings *recips, const AnsiString &gate);
void __fastcall hashcashgrabtokens(TStrings *message, TStrings *tokens);
void __fastcall hashcashaddheader(TStrings *message, const AnsiString &header);
AnsiString __fastcall hashcashgettoken(TStrings *alltokens, const AnsiString &gateway, int validperiod);
bool __fastcall hashcashexistingtoken(TStrings *tokens, const AnsiString &gate);
TDateTime __fastcall hashcashtokendate(const AnsiString &token, int validperiod);
TDateTime __fastcall getcurrentGMTdate();

const AnsiString HashCashHdr = "X-Hashcash: ";
const int hcMail2news = 0;
const int hcResource = 1;
const int hcValidity = 2;
const int hcDBName = 3;
//---------------------------------------------------------------------------
extern THashCashDlg *HashCashDlg;
//---------------------------------------------------------------------------
#endif
