/*
*  MIMEman4.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#include <sys\stat.h>
#include <math.h>
#pragma hdrstop

#include "MIMEman4.h"
#include "MIMEmanEnc.h"
#include "MIMEmanDec.h"
#include "Fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMIMEdlg *MIMEdlg=NULL;
#define MaxLineLength 76
//TEMPORARY DEF FOR TESTING
//#define DETACH_STRIPHTML true
//---------------------------------------------------------------------------
// TMIMEdlg
//---------------------------------------------------------------------------
__fastcall TMIMEdlg::TMIMEdlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMIMEdlg::TMIMEdlg(TComponent *Owner, AnsiString caption)
   : TForm(Owner)
{
   CenterDialog(this,Owner);
   Filename->Caption = "";
   Caption = caption;
   decoder = NULL;
   encoder = NULL;
   cancel = NULL;
}
//---------------------------------------------------------------------------
int  __fastcall TMIMEdlg::DecodeAttachments(TMIMEdecoder *Decoder)
{
   decoder = Decoder;
   CancelBtn->Visible = false; Height -= 12;
   ShowModal(); return ModalResult;
}
//---------------------------------------------------------------------------
int  __fastcall TMIMEdlg::EncodeAttachments(TMIMEencoder *Encoder)
{
   encoder = Encoder;
   ShowModal(); return ModalResult;
}
//---------------------------------------------------------------------------
void __fastcall TMIMEdlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Timer2->Enabled = false;
   //Caption = DecodingAttachments;
   if (decoder) decoder->DecodeAttachments(); else
   if (encoder) encoder->EncodeAttachments();
   Snooze(100);
}
//---------------------------------------------------------------------------
void __fastcall TMIMEdlg::CancelBtnClick(TObject *Sender)
{
   if (ConfirmBox(this,"Cancel operation?            ",MB_YESNO)==IDNO)
      return;
   if (cancel) *cancel = true;
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TMIMEdlg::FormShow(TObject *Sender)
{
   Timer1->Enabled = true; Timer2->Enabled = true;
   if (decoder) cancel = &decoder->cancel;
   if (encoder) cancel = &encoder->cancel;
}
//---------------------------------------------------------------------------
void __fastcall TMIMEdlg::Timer2Timer(TObject *Sender)
{
   Caption = Caption + ".";
   AppProcessMessages();
}
//---------------------------------------------------------------------------
// UTILITIES
//---------------------------------------------------------------------------
bool __fastcall HasAttached(TStrings *message) // inbound
{
   return message->Text.Pos("Content-Disposition: attachment")>0;
}
//---------------------------------------------------------------------------
bool __fastcall HasAttachments(TStrings *message)
{
   bool has=false;
   for (int i=0; i<message->Count; i++)
   {
      AnsiString line = message->Strings[i].Trim().LowerCase();
      if (line.IsEmpty()) break;
      if (line.Pos("attachment: ")==1)
      {
         has = true;
         break;
      }
   }
   return has;
}
//---------------------------------------------------------------------------
void __fastcall StripHTML(TStrings *part)
{
   AnsiString body=part->Text;
   int len,pos,pos1,pos2;
   part->BeginUpdate();
   part->Clear();
   while(true)
   {
      pos1=body.Pos("<"); pos2=body.Pos(">");
      if (pos2<pos1)
      {
         body.Delete(pos2,1);
         continue;
      }
      len = pos2-pos1+1;
      if (len>0) body.Delete(pos1,len);
      if (body.Pos(">")==0)
         break;
   }
   while ((pos=body.Pos("&quot;"))>0) { body.Delete(pos,6); body.Insert("\"",pos); }
   while ((pos=body.Pos("&amp;" ))>0) { body.Delete(pos,5); body.Insert("&", pos); }
   while ((pos=body.Pos("&nbsp;"))>0) { body.Delete(pos,6); body.Insert(" ", pos); }
   while ((pos=body.Pos("&lt;"  ))>0) { body.Delete(pos,4); body.Insert("<", pos); }
   while ((pos=body.Pos("&gt;"  ))>0) { body.Delete(pos,4); body.Insert(">", pos); }
   while ((pos=body.Pos("&copy;"))>0) { body.Delete(pos,6); body.Insert("", pos); }
   while ((pos=body.Pos("&laquo;"))>0) { body.Delete(pos,7); body.Insert("", pos); }
   while ((pos=body.Pos("&raquo;"))>0) { body.Delete(pos,7); body.Insert("", pos); }
   while ((pos=body.Pos("&brvbar;"))>0) { body.Delete(pos,8); body.Insert("|", pos); }
   while ((pos=body.Pos("&frac14;"))>0) { body.Delete(pos,8); body.Insert("", pos); }
   while ((pos=body.Pos("&frac12;"))>0) { body.Delete(pos,8); body.Insert("", pos); }
   while ((pos=body.Pos("&frac34;"))>0) { body.Delete(pos,8); body.Insert("", pos); }
   while ((pos=body.Pos("&Ntilde;"))>0) { body.Delete(pos,8); body.Insert("", pos); }
   while ((pos=body.Pos("&ntilde;"))>0) { body.Delete(pos,8); body.Insert("", pos); }
   while ((pos=body.Pos("&THORN;"))>0) { body.Delete(pos,7); body.Insert("", pos); }
   while ((pos=body.Pos("&thorn;"))>0) { body.Delete(pos,7); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   //while ((pos=body.Pos(""))>0) { body.Delete(pos,); body.Insert("", pos); }
   part->Text = body;

   TrimNulls(part);
   part->Insert(0,"*** HTML Stripped ***\n");
   part->Add("\n*** HTML Stripped ***");
   part->EndUpdate();
}
//---------------------------------------------------------------------------
AnsiString __fastcall dropquotes(AnsiString line)
{
   int f=1,l=line.Length();
   if (l<3) return "";

   if (line[f]=='\"') { f++; l-=2; }
   if (line[l]=='\"') l--;
   return line.SubString(f,l);
}
//---------------------------------------------------------------------------
bool __fastcall GetAttachments(TStrings *files, TStrings *Message)
{
   files->Clear();
   AnsiString line,file,fileline;
   bool gotfiles = false;
   int i=-1; while(++i<Message->Count)
   {
      line = Message->Strings[i];
      if (line.Trim().IsEmpty()) break;
      if (line.LowerCase().Pos("Attachment: ")==1)
      {
         fileline = line.SubString(13,1024).Trim();
         while(++i<Message->Count)
         {
            line = Message->Strings[i];
            if (line.Length() && (line[1]==' ' || line[1]=='\t'))
               fileline += " "+line.Trim();
            else break;
         }
         gotfiles = true;
      }
      if (gotfiles)
         break;
   }
   i=-1; while(!(file=GetToken(++i,fileline,";")).IsEmpty())
      files->Add(file.Trim());
   return files->Count>0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetValidUniqueFilename(AnsiString &filename)
{
   AnsiString ext,xstr,path=ExtractFilePath(filename),name=ExtractFileName(filename);
   // correct name only, valid path provided by QS
   for (int i=1; i<=name.Length(); i++)
      if (s("\/:*?\"<>|").Pos(name[i])>0) name[i] = '_';
   // parse ext and name without ext
   ext = ExtractFileExt(name);
   name = name.SubString(1,name.Length()-ext.Length());
   int x=0; while(FileExists(path+name+xstr+ext)) xstr = s(++x);
   return path+name+xstr+ext;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetBoundaryNumberEx()
{
   AnsiString number,boundary;
   long double num = (double)Now()*(double)GetTickCount();
   boundary = number.FloatToStrF(num,AnsiString::sffFixed,15,4);
   int pos=boundary.Pos(".");
   if (pos>0) boundary[pos] = '_';
   return boundary;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetPrimary(AnsiString &field, AnsiString &content)
{
   AnsiString line;
   int i=-1; while(!(line=GetToken(++i,content,";").Trim()).IsEmpty())
   {
      if (line.Trim().LowerCase().Pos(field)==1)
         return dropquotes(line.SubString(field.Length()+2,1024).Trim());
   }
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetPrimaryContent(TStrings *mime)
{
   bool gotcontent=false;
   AnsiString line,contenttype;
   int i=-1; while(++i<mime->Count)
   {
      line = mime->Strings[i].Trim();
      if (line.IsEmpty()) break;
      if (line.LowerCase().Pos("content-type:")==1)
      {
         mime->Delete(i);
         contenttype += line;
         while(i<mime->Count)
         {
            line = mime->Strings[i];
            if (line.IsEmpty()) break;
            if (s(" \t").Pos(line[1])>0 || line.LowerCase().Pos("content-")==1)
            {
               if (contenttype.Length() && contenttype[contenttype.Length()]!=';')
                  contenttype += ";";
               contenttype += " "+line.Trim();
               mime->Delete(i);
               gotcontent = true;
               continue;
            }
            gotcontent = true;
            break;
         }
         if (gotcontent)
            break;
      }
      if (gotcontent)
         break;
   }
   return contenttype;
}
//---------------------------------------------------------------------------
bool __fastcall IsMIME(TStrings *Message)
{
   int x=-1,i=-1; while(++i<Message->Count)
   {
      if (x>=0 && i==x+32) break;
      AnsiString line = Message->Strings[i].Trim().LowerCase();
      if (line.IsEmpty() && x<0) x = i;
      if (line.Pos("content-type: ")==1)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall IsPgpMIME(TStrings *Message)
{
   int i=-1; while(++i<Message->Count)
   {
      AnsiString line = Message->Strings[i].LowerCase();
      if (line.Trim().IsEmpty()) break;
      if (line.Pos("content-type: multipart/encrypted")==1)
      {
         while(true)
         {
            if (line.Pos("protocol=\"application/pgp-encrypted\"")>0)
               return true;
            line = Message->Strings[++i].LowerCase();
            if (s(" \t").Pos(line.SubString(1,1))==0)
               break;
         }
      }
      if (line.Pos("content-type: multipart/signed")==1)
      {
         while(true)
         {
            if (line.Pos("protocol=\"application/pgp-signature\"")>0)
               return true;
            line = Message->Strings[++i].LowerCase();
            if (s(" \t").Pos(line.SubString(1,1))==0)
               break;
         }
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall DecodePgpMIMEmessage(TStrings *Message)
{
   AnsiString contenttype,protocol,boundary;
   AnsiString content=GetPrimaryContent(Message);
   contenttype=GetPrimary("content-type:",content);
   protocol=GetPrimary("protocol=",content);
   boundary=GetPrimary("boundary=",content);

   if (contenttype=="multipart/encrypted" && protocol=="application/pgp-encrypted")
   {
      int idx=Message->IndexOf("--"+boundary);
      if (idx>=0)
      {
         Message->BeginUpdate();
         Message->Delete(idx);
         while(Message->Strings[idx]!="-----BEGIN PGP MESSAGE-----")
            Message->Delete(idx);
         TrimNullsAfter(Message);
         if (Message->Strings[Message->Count-1]=="--"+boundary+"--")
            Message->Delete(Message->Count-1);
         TrimNullsAfter(Message);
         Message->EndUpdate();
         return true;
      }
   }
   if (contenttype=="multipart/signed" && protocol=="application/pgp-signature")
   {
      int idx=Message->IndexOf("--"+boundary);
      if (idx>=0)
      {
         Message->Delete(idx);
         while(Message->Strings[idx].IsEmpty()) Message->Delete(idx);
         idx=Message->IndexOf("--"+boundary);
         if (idx>=0)
         {
            Message->Delete(idx);
            if (Message->Strings[idx].Pos("application/pgp-signature")>0)
            {
               Message->Delete(idx);
               while(Message->Strings[idx].Trim().IsEmpty())
                  Message->Delete(idx);
            }
            TrimNullsAfter(Message);
            if (Message->Strings[Message->Count-1]=="--"+boundary+"--")
               Message->Delete(Message->Count-1);
            TrimNullsAfter(Message);
            return true;
         }
      }
   }
   return false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetCreateAttachmentDir()
{
   AnsiString dir = GetAppIni(AttachDirectory,"");
   if (!dir.IsEmpty() && !DirectoryExists(dir)) ForceDirectories(dir);
   if (!DirectoryExists(dir))
   {
      dir = AppDir+"attachments";
      ForceDirectories(dir);
      if (!DirectoryExists(dir)) dir = AppDir;
      PutAppIni(AttachDirectory,dir);
   }
   return dir;
}
//---------------------------------------------------------------------------





