/*
*  MailboxWins.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MailboxWinsH
#define MailboxWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "Grids.hpp"
#include <vcl\Buttons.hpp>
#include <vcl\Menus.hpp>
#include "global.h"
//---------------------------------------------------------------------------
class TMailboxWin;

TMailboxWin* __fastcall OpenMailbox(AnsiString &Boxname);
TMailboxWin* __fastcall FindOpenMailbox(AnsiString &Boxname);
AnsiString __fastcall CreateMailbox(AnsiString &Boxname=s("")); // empty string brings up intertactive dialog
void __fastcall DelMailbox(AnsiString &Boxname);
bool __fastcall DelMenubox(AnsiString &Boxname);
void __fastcall AddMenubox(AnsiString &Boxname);
void __fastcall DelMailboxPos(AnsiString &Boxname); // delete message index position
void __fastcall SetMailboxPos(AnsiString &Boxname, long position);
bool __fastcall MailboxExists(AnsiString &Boxname);
bool __fastcall MenuboxExists(AnsiString &Boxname);
// Selected, below, is the array of bools from currently open index window
// alternatively it can be NULL, indicating delete/transfer ALL
long __fastcall TransferMessages(AnsiString &Boxname, bool *Selected, TStrings *MailList,
   AnsiString &Newname, bool *anchor);
// if Selected != NULL then MailList cannot be NULL
long __fastcall DelMessages(AnsiString &Boxname, bool *Selected,  TStrings *MailList);

const AnsiString HeaderText = "Date Who Subject S";

class TMailGrid : public TDrawGrid
{
private:
protected:
   void __fastcall DrawCell(long ACol, long ARow, const Windows::TRect &Rect,
      TGridDrawState State);
   void __fastcall KeyDown(unsigned short &Key, TShiftState Shift);
   void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift,
      int X, int Y);
   void __fastcall DblClick();
public:
   long Anchor;
   bool *Selected;
   AnsiString Mailbox;
   TStringList *MailList, *alerts;
   int LastLeftCol;
   __fastcall virtual TMailGrid(TComponent *Owner);
   __fastcall virtual TMailGrid(TComponent *Owner, AnsiString &BoxName);
   __fastcall virtual~TMailGrid();
   AnsiString __fastcall BoxName() { return Mailbox; };
   AnsiString __fastcall MessageSubject(AnsiString &IndexStr);
   AnsiString __fastcall MessageDate(AnsiString &IndexStr);
   AnsiString __fastcall MessageWho(AnsiString &IndexStr);
   void __fastcall OpenIndex(bool sorted);
   void __fastcall CloseIndex();
   void __fastcall RefreshIndex();
   void __fastcall SetBoxPos(int pos);
   int  __fastcall GetBoxPos();
   long __fastcall TransferSelected(AnsiString &MailBox);
   long __fastcall DeleteSelected();
   long __fastcall ClearSelected();
   void __fastcall SetSelected(long Anchor, long ToRow=-1);
   long __fastcall OpenSelected();
   long __fastcall GridRow(long Row); // test for validity of row--not too low or high
   long __fastcall SelCount();
   void __fastcall SelectAll();
   void __fastcall SortList(bool sorted);
 //void __fastcall TopLeftChanged(TObject *Sender);
};

class TMailboxWin : public TForm
{
__published:	// IDE-managed Components
  TPopupMenu *PopupMenu;
  TMenuItem *PopupTransferItem;
  TMenuItem *PopupDeleteItem;
  TMenuItem *PopupMailboxMenuItem;
  TMenuItem *N1;
  TMenuItem *PopupDeleteMailboxItem;
  TMenuItem *N2;
  TMenuItem *PopupOpenItem;
  TMenuItem *N5;
  TMenuItem *PopSelectAllItem;
  TMenuItem *PopupSortedItem;
  TMenuItem *PopFindItem;
	TMenuItem *PopupDeleteItem2;
  void __fastcall FormResize(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall PopupDeleteItemClick(TObject *Sender);
  void __fastcall PopupMailboxMenuItemClick(TObject *Sender);
  void __fastcall PopupTransferItemClick(TObject *Sender);
  void __fastcall PopupRefreshItemClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall PopupMenuPopup(TObject *Sender);
  void __fastcall PopupOpenItemClick(TObject *Sender);
  void __fastcall PopupDeleteMailboxItemClick(TObject *Sender);
  void __fastcall EditSelectAllItemClick(TObject *Sender);
  void __fastcall PopSelectAllItemClick(TObject *Sender);
  void __fastcall PopupSortedItemClick(TObject *Sender);
  void __fastcall PopFindItemClick(TObject *Sender);
        void __fastcall PopupBlockSubjectItemClick(TObject *Sender);
        void __fastcall PopupBlockSenderItemClick(TObject *Sender);
        
        
        
private:	// User declarations
public:		// User declarations
  TMailGrid *MailGrid;
  virtual __fastcall TMailboxWin(TComponent* Owner);
  virtual __fastcall TMailboxWin(TComponent* Owner, AnsiString &Boxname);
  virtual __fastcall~TMailboxWin();
  AnsiString __fastcall Boxname() { return Caption; }
  long __fastcall GoNewMessages();
  void __fastcall RefreshIndex();
};
//---------------------------------------------------------------------------
extern TMailboxWin *MailboxWin;
//---------------------------------------------------------------------------
#endif
