/*
*  MixMsg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MixThreadH
#define MixThreadH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include "headman.h"
//---------------------------------------------------------------------------
void __fastcall MixmasterPoolClear(); // clears the mixmaster 'pool' subdir
long __fastcall MixPoolGet(TStrings *Message, AnsiString &Name, int atPos);
long __fastcall MixPoolAdd(TStrings *Message, AnsiString &Name);
void __fastcall MixPoolDelete(int atPos);
void __fastcall MixPoolDeleteFile();
long __fastcall MixPoolCount();
#define MSG_POST 2

class TMixMessage
{
private:
   long __fastcall MixMessage(TStrings *Message, AnsiString &Chain, int copies,
      TStringList *Feedback);
protected:
public:
   TForm *Owner;
   int Copies;
   AnsiString Msg;
   TStrings *display;
   bool Finished, Cancelled;
   AnsiString From, Host, Chain;
   THeaderManager *HeadMan;
   TProgressBar *ProgressBar;
   TStringList *Message, *Feedback;
   __fastcall TMixMessage(TForm *Owner, TStringList *message, TStrings *aDisplay,
      TProgressBar *progressbar, TStringList *Feedback);
   __fastcall ~TMixMessage();
   void __fastcall MassageHeaders(TStrings *Message, bool &IsPost);
   bool __fastcall IsRandomOrMix204(const AnsiString &remailer);
   bool __fastcall IsMix204(const AnsiString &remailer);
   long __fastcall Execute(int tries = 1);
};

const AnsiString MixmasterChain = "Mixmaster Chain";
//---------------------------------------------------------------------------
#endif
