/*
*  MixMsg.x.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\ComCtrls.hpp>
#include <filectrl.hpp>
#pragma hdrstop

#include "MixMsg.x.h"
#include "mixmaster.h"
#include "BrokeChnDlgs.h"
#include "MixDupChnDlgs.h"
#include "pgp.h"
#include "global.h"
#include "headman.h"
#include "wipedlgs.h"
#include "console.h"
#include "QSver.h"
#include "fileman.h"
#include "view.h"
#define DISPLAY(msg) display->Add(msg)
//---------------------------------------------------------------------------
void __fastcall MixPoolDeleteFile()
{
   if (FileExists(AppMixPool) && simplewipe(AppMixPool) == WIPE_OK) // wipe the QS mixpool
      DeleteFile(AppMixPool.c_str());
}
//---------------------------------------------------------------------------
void __fastcall MixPoolDelete(int atPos)
{
   TStringList *pool = new TStringList();
   TStringList *message = new TStringList();
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   if (pool->Count>atPos)
      PutAppData(MixPoolKey+PS+pool->Strings[atPos],NULL,AppMixPool); // delete from pool
   if (!MixPoolCount()) MixPoolDeleteFile();
   delete message;
   delete pool;
}
//---------------------------------------------------------------------------
long __fastcall MixPoolGet(TStrings *Message, AnsiString &Name, int atPos)
{
   Name = "";
   Message->Clear();
   TStringList *pool = new TStringList();
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   if (pool->Count>atPos)
   {
      Name = pool->Strings[atPos];
      GetAppData(Message,MixPoolKey+PS+Name,AppMixPool); // get first message
   }
   delete pool;
   return atPos;
}
//---------------------------------------------------------------------------
long __fastcall MixPoolAdd(TStrings *Message, AnsiString &Name)
{
   int msgs;
   TStringList *pool = new TStringList();
   PutAppData(MixPoolKey+PS+Name,Message,AppMixPool);
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   msgs = pool->Count;
   delete pool;
   return msgs;
}
//---------------------------------------------------------------------------
long __fastcall MixPoolCount()
{
   int count=0;
   if (FileExists(AppMixPool))
   {
      TStringList *pool = new TStringList();
      GetAppData(pool,MixPoolKey,AppMixPool);
      count = pool->Count;
      delete pool;
   }
   return count;
}
//---------------------------------------------------------------------------
void __fastcall MixmasterPoolClear()
{
//sm("ok1");
   AnsiString file,mixpool=MixDir()+"pool\\";
   if (!DirectoryExists(mixpool)) return;

   TStringList *files = new TStringList();
   GetFilenames(files,mixpool+"*.*");
   for (int i=0; i<files->Count; i++)
   {
      file = files->Strings[i];
      if (file==AppMixPool) MixPoolDeleteFile();
      else DeleteFile(file.c_str());
   }
   delete files;
   //RemoveDirectory(mixpool.c_str());
//sm("ok2");
}
//---------------------------------------------------------------------------
__fastcall TMixMessage::TMixMessage(TStringList *message, TStrings *aDisplay,
   TProgressBar *progressbar, TStringList *theFeedback)
{
   Finished = false;
   Cancelled = false;
   Message = message;
   display = aDisplay;

   HeadMan = new THeaderManager(Message);
   From = HeadMan->Get("From: "); HeadMan->Delete("From: ");
   Host = HeadMan->Get("Host: "); HeadMan->Delete("Host: ");
   AnsiString tmpc = HeadMan->GetDat("Chain: ",Message);
   if (tmpc.SubString(tmpc.Length(),1)==";") tmpc.Delete(tmpc.Length(),1);
   HeadMan->Delete("Chain: ");
   HeadMan->Delete("Fcc: ");

   Copies = GetParam(1,tmpc,"=").Trim().ToIntDef(1); if (Copies==0) Copies++;
   Chain = GetParam(0,tmpc,";").Trim(); tmpc = GetParam(1,tmpc,";").Trim();
   ProgressBar = progressbar;
   Feedback = theFeedback;
   MixmasterPoolClear();
}
//---------------------------------------------------------------------------
__fastcall TMixMessage::~TMixMessage()
{
   MixmasterPoolClear();
   delete HeadMan;
}
//---------------------------------------------------------------------------

void __fastcall TMixMessage::MassageHeaders(TStrings *Message, bool &IsPost)
{
   int idx, pos;
   THeaderManager *hm = new THeaderManager(Message);

   AnsiString post = hm->GetDat("Post: ");
   IsPost = !post.IsEmpty();
   if (IsPost)
   {
      idx = hm->Delete("Post: ");
      Message->Insert(idx < 0 ? 0 : idx, "Newsgroups: " + post);
   }

   AnsiString hdr, hdl;
   TStringList *recips = new TStringList();
   TStringList *headers = new TStringList();
   while ((hdr = hm->PopHeader()) != "")
   {
      hdl = hdr.LowerCase();
      if (hdl.Pos("to: ") == 1 || hdl.Pos("cc: ") == 1 || hdl.Pos("bcc: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" ,")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(", ")) > 0) hdr.Delete(pos + 1, 1);
         recips->Add(hdr);
         continue;
      }

      if (hdl.Pos("references: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" " )) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("><")) > 0) hdr.Insert(" ", pos + 1);
         headers->Add(hdr);
         continue;
      }

      if (hdl.Pos("newsgroups: ") == 1)
      {
         while ((pos = hdr.Pos("\r")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos("\t")) > 0) hdr.Delete(pos, 1);
         while ((pos = hdr.Pos(" "))  > 0) hdr.Delete(pos, 1);
         headers->Add(hdr);
         continue;
      }

      while ((pos = hdr.Pos("\r")) > 0)
      {
         hdr.Delete(pos, 1);
         hdr.Insert(" ", pos);
      }
      while ((pos = hdr.Pos("\n")) > 0) hdr.Delete(pos, 1);
      while ((pos = hdr.Pos("\t")) > 0)
      {
         hdr.Delete(pos, 1);
         hdr.Insert(" ", pos);
      }
      headers->Add(hdr);
   }

   if (headers->Count)
   {
      for (int i = 0; i < headers->Count; i++)
         Message->Insert(i, headers->Strings[i]);
      Message->Insert(0, "##");
   }

   if (recips->Count)
   {
      for (int i = 0; i < recips->Count; i++)
      {
         Message->Insert(i, recips->Strings[i]);
         if (i == recips->Count - 1)
            Message->Insert(i + 1, "");
      }
   }

   delete headers;
   delete hm;
}
//---------------------------------------------------------------------------

long __fastcall TMixMessage::MixMessage(TStrings *Message, AnsiString &Chain, int copies,
   TStringList *Feedback)
{
   int ret;
   bool ispost;
   BUFFER *msg = buf_new(); assert(msg != NULL);
   BUFFER *fbk = buf_new(); assert(fbk != NULL);
   msg->sensitive = true; fbk->sensitive = true;

view(Message);
   MassageHeaders(Message, ispost);
//view(Message);

   for (int i = 0; i < Message->Count; i++)
   {
      AnsiString line = Message->Strings[i]+"\n";
      buf_append(msg,(byte*)line.c_str(),line.Length());
   }

   if ((ret = mix_encrypt((ispost ? MSG_POST : MSG_MAIL), msg, Chain.c_str(), copies, fbk)) == 0)
       mix_send();

   Feedback->Text = AnsiString((char*)fbk->data);
   for (int i = 0; i < Feedback->Count; i++)
      Feedback->Strings[i].Insert(" ", 1);

   buf_free(msg);
   buf_free(fbk);

   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall StringInList(AnsiString &String, TStringList *List)
{
   bool isin=false;
   for (int i=0; i<List->Count; i++)
   {
      if (List->Strings[i]==String)
      {
         isin = true;
         break;
      }
   }
   return isin;
}
//---------------------------------------------------------------------------
void DeleteStrings(TStrings *FromList, TStrings *ThatAreInList)
{
   int f=0; while (f<FromList->Count)
   {
      int pos = -1;
      for (int i=0; i<ThatAreInList->Count; i++)
      {
         if (FromList->Strings[f]==ThatAreInList->Strings[i])
         {
            pos = f;
            break;
         }
      }
      if (pos>=0)
         FromList->Delete(pos);
      else
         f++;
   }
}
//---------------------------------------------------------------------------
/*long __fastcall TMixMessage::Execute()
{
   long ret=0;
   AnsiString file,text,name,curstr;
   if (Cancelled) { Finished = true; return ret; }

   TStringList *prefiles = new TStringList();
   GetFilenames(prefiles,QUEUEFILES);
   DISPLAY("Mixmaster encrypting... ");
   Application->ProcessMessages();

   if ((ret = MixMessage(Message, Chain, Copies, Feedback)) == 0)
   {
      TStringList *msg = new TStringList();
      TStringList *outfiles = new TStringList();
      GetFilenames(outfiles,QUEUEFILES);
      if (!Cancelled)
      {
         AnsiString S = Feedback->Count==1 ? "":"s";
         DISPLAY("Mixmaster reports "+s(Feedback->Count)+" chain"+S+": ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            AppProcessMessages();
         }
         if (!HasBrokenMixChainAfterEncrypt(AppMainForm,","+Chain+",",Feedback) &&
             !HasDuplicateMixChainsAfterEncrypt(AppMainForm,Feedback))
         {
            DeleteStrings(outfiles,prefiles);
            for (int i=0; i<outfiles->Count; i++)
            {
               file = outfiles->Strings[i];
               if (!Cancelled)
               {
                  curstr = (i+1<10? " ":"")+AnsiString(i+1);
                  name = MixmasterChain+" "+curstr+" of "+AnsiString(outfiles->Count);
                  msg->LoadFromFile(file); msg->Delete(0);
                  msg->Insert(0,Host);
                  msg->Insert(1,From);
                  msg->SaveToFile(file);
                  MixPoolAdd(msg,name);
               }
               DeleteFile(file.c_str());
            }
         }
         else Cancelled = true;
      }
      if (Cancelled) MixPoolDeleteFile();
      delete outfiles;
      delete msg;
   }
   delete prefiles;

   if (!Cancelled && ret!=0)
   {
      DISPLAY("Mixmaster reports error condition: ");
      for (int i=0; i<Feedback->Count; i++)
      {
         DISPLAY(Feedback->Strings[i]);
         Application->ProcessMessages();
      }
   }
   Finished = true;
   return ret;
}*/
//---------------------------------------------------------------------------
long __fastcall TMixMessage::Execute()
{
   long ret=0;
   AnsiString file,text,name,curstr;
   if (Cancelled) { Finished = true; return ret; }

   TStringList *prefiles = new TStringList();
   GetFilenames(prefiles,QUEUEFILES);

   TStringList *clrmessage = new TStringList();
   clrmessage->AddStrings(Message);

   DISPLAY("Mixmaster encrypting... ");
   Application->ProcessMessages();

   if ((ret = MixMessage(Message, Chain, Copies, Feedback)) == 0)
   {
      /*static int x = 0;
      if (x == 0)
      {
         Feedback->Clear();
         Feedback->Add("frog,aarg");
         Feedback->Add("bogg,frog");
         //Feedback->Add("rot26,aarg");
         //Feedback->Add("rot26,aarg");
      }
      x = 1;*/

      TStringList *msg = new TStringList();
      TStringList *outfiles = new TStringList();
      GetFilenames(outfiles, QUEUEFILES);

      if (!Cancelled)
      {
         AnsiString S = Feedback->Count == 1 ? "" : "s";
         DISPLAY("Mixmaster reports " + s(Feedback->Count) + " chain" + S + ": ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            AppProcessMessages();
         }

         if (HasBrokenMixChainAfterEncrypt(AppMainForm, Feedback, Cancelled) ||
             HasDuplicateMixChainsAfterEncrypt(AppMainForm, Feedback, Cancelled))
         {
            DeleteStrings(outfiles, prefiles);
            for (int i=0; i<outfiles->Count; i++)
               DeleteFile(outfiles->Strings[i].c_str());
            MixPoolDeleteFile();

            Message->Clear();
            Message->AddStrings(clrmessage);

            if (!Cancelled) DISPLAY("starting again...\n");
            else DISPLAY("");

            Execute();
            goto exit;
         }
         else
         {
            DeleteStrings(outfiles, prefiles);

            for (int i=0; i<outfiles->Count; i++)
            {
               file = outfiles->Strings[i];
               if (!Cancelled)
               {
                  curstr = (i + 1 < 10? " " : "") + AnsiString(i + 1);
                  name = MixmasterChain + " " + curstr + " of " + AnsiString(outfiles->Count);
                  msg->LoadFromFile(file); msg->Delete(0);
                  msg->Insert(0, Host);
                  msg->Insert(1, From);
                  msg->SaveToFile(file);
                  MixPoolAdd(msg, name);
               }

               DeleteFile(file.c_str());
            }
         }
      }
      else MixPoolDeleteFile();
exit:
      delete outfiles;
      delete msg;
   }

   delete clrmessage;
   delete prefiles;

   if (!Cancelled && ret != 0)
   {
      DISPLAY("Mixmaster reports error condition: ");
      for (int i = 0; i < Feedback->Count; i++)
      {
         DISPLAY(Feedback->Strings[i]);
         Application->ProcessMessages();
      }
   }
   Finished = true;
   return ret;
}
//---------------------------------------------------------------------------


