/*
*  RemShortNameDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Global.h"
#include "RemShortNameDlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TRemShortNameDlg *RemShortNameDlg;

const AnsiString ChangeNameMessage =
 "On rare occassions you may find a remailer key or, more likely, a nymserver "
 "key, with the short name 'nameless'. The reason for this is that QS has no "
 "record of this server's short name. That means the name is not listed in "
 "either the caps section of current rlist.txt or the database QS maintains "
 "of actual short names it has encountered in the past. You can use this dialog "
 "to add the actual short name to the QS database or possibly correct an "
 "incorrect name you have added on an earlier occassion.";
//---------------------------------------------------------------------------

bool __fastcall GetRemailerShortName(TForm *Owner, const AnsiString &RemailerAddress,
   AnsiString &ShortName)
{
   RemShortNameDlg = new TRemShortNameDlg(Owner);
   RemShortNameDlg->Label1->Caption = RemailerAddress;
   RemShortNameDlg->ShortName->Text = ShortName;

   RemShortNameDlg->ShowModal();
   bool ok = RemShortNameDlg->ModalResult == mrOk;
   if (ok)
   {
      ShortName = RemShortNameDlg->ShortName->Text;
   }

   delete RemShortNameDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TRemShortNameDlg::TRemShortNameDlg(TComponent* Owner)
        : TForm(Owner)
{
   CenterDialog(this, Owner);
}
//---------------------------------------------------------------------------

void __fastcall TRemShortNameDlg::FormCloseQuery(TObject *Sender,
        bool &CanClose)
{
   if (ModalResult == mrOk && ShortName->Text.Length() > 8)
   {
      MsgDlg(this,
         "Name can have 8 characters max.    ",
         "Information",
          MB_OK
      );
      CanClose = false;
      ActiveControl = ShortName;
      return;
   }

   if (ModalResult == mrOk && ShortName->Text == "")
   {
      MsgDlg(this,
         "You must enter name or click Cancel .   ",
         "Information",
          MB_OK
      );
      CanClose = false;
      return;
   }

   if (ModalResult == mrOk && ShortName->Text == OrgShortName)
   {
      MsgDlg(this,
         "You must modify the original name or click Cancel.    ",
         "Information",
          MB_OK
      );
      CanClose = false;
      return;
   }
}
//---------------------------------------------------------------------------

void __fastcall TRemShortNameDlg::FormShow(TObject *Sender)
{
   Message->Lines->Text = ChangeNameMessage;
   OrgShortName = ShortName->Text;
}
//---------------------------------------------------------------------------
