/*
*  SMTPAuthDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SMTPAuthDlgs.h"
#include "SMTPPassDlgs.h"
#include "helpdlgs.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TSMTPAuthDlg *SMTPAuthDlg;
//---------------------------------------------------------------------------
void __fastcall ManageSMTPPasswords(TForm *Owner)
{
   SMTPAuthDlg = new TSMTPAuthDlg(Owner);
   SMTPAuthDlg->ShowModal();
   delete SMTPAuthDlg;
}
//---------------------------------------------------------------------------
__fastcall TSMTPAuthDlg::TSMTPAuthDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   GetAppData(HostList->Items,SMTPAuthenticHosts);
   modified = false;
}
//---------------------------------------------------------------------------
__fastcall TSMTPAuthDlg::~TSMTPAuthDlg()
{
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::HostListClick(TObject *Sender)
{
   if (HostList->ItemIndex>=0)
   {
      DeleteBtn->Enabled = true;
      EditBtn->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && modified) PutAppData(SMTPAuthenticHosts,HostList->Items);
   if (ModalResult==mrCancel && modified)
   {
      switch(MsgBoxHwnd(Handle,
        "Your host list is modified.\n\nSave your changes?",
        "Confirm",MB_YESNOCANCEL))
      {
         case IDYES: PutAppData(SMTPAuthenticHosts,HostList->Items); break;
         case IDCANCEL: CanClose = false; break;
      }
   }
   if (ModalResult==mrOk && !modified)
      ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::NewBtnClick(TObject *Sender)
{
   AnsiString host,userid,password;
   if (SMTPGetHostUidPassword(this,host,userid,password))
   {
      //HostList->Sorted = false;
      //HostList->Items->Values[host] = userid+"\255"+password;
      HostList->Items->Add(host+"="+userid+"\255"+password);
      //HostList->Sorted = true;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::EditBtnClick(TObject *Sender)
{
   if (HostList->ItemIndex<0) return;
   AnsiString host,userid,password,data=HostList->Items->Strings[HostList->ItemIndex];
   int pos = data.Pos("=");
   host = data.SubString(1,pos-1);
   userid = GetToken(0,data.SubString(pos+1,128),"\255");
   password = GetToken(1,data.SubString(pos+1,128),"\255");
   if (SMTPGetHostUidPassword(this,host,userid,password))
   {
      HostList->Sorted = false;
      HostList->Items->Strings[HostList->ItemIndex] = host+"="+userid+"\255"+password;
      HostList->Sorted = true;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::DeleteBtnClick(TObject *Sender)
{
   if (HostList->ItemIndex<0) return;
   if (MsgBoxHwnd(Handle,"Delete the current host?","Confirm",MB_OKCANCEL)==IDOK)
   {
      HostList->Items->Delete(HostList->ItemIndex);
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::FormShow(TObject *Sender)
{
   if (!HostList->Items->Count) ActiveControl = NewBtn;
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::HostListDblClick(TObject *Sender)
{
   if (HostList->ItemIndex>=0) EditBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::HostListDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
   AnsiString uid,host,data=HostList->Items->Strings[Index];
   int pos = data.Pos("=");
   host = data.SubString(1,pos-1);
   uid = GetToken(0,data.SubString(pos+1,128),"\255");
   HostList->Canvas->FillRect(Rect);
   HostList->Canvas->TextRect(Rect,Rect.Left+2,Rect.Top,uid+"@"+host);
}
//---------------------------------------------------------------------------
void __fastcall TSMTPAuthDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("SendingMail","Password Authentication","");
}
//---------------------------------------------------------------------------
