/*
*  backupthrds.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BackupThrds.h"
#include "WipeDlgs.h"
#include "global.h"
TBackupThrd *BackupThrd;
//---------------------------------------------------------------------------
bool  __fastcall RunBackupThread(TForm *Owner, AnsiString Path, AnsiString Name, int Copies)
{
   BackupThrd = new TBackupThrd(true);
   BackupThrd->copies = Copies;
   BackupThrd->owner = Owner;
   BackupThrd->path = Path;
   BackupThrd->name = Name;
   BackupThrd->Resume();
   return true;
}
//---------------------------------------------------------------------------
__fastcall TBackupThrd::TBackupThrd(bool CreateSuspended)
	: TThread(CreateSuspended)
{
   OnTerminate = ThreadTerminate;
   FreeOnTerminate = true;
}
//---------------------------------------------------------------------------
void __fastcall TBackupThrd::Execute()
{
   lasterror = 0;
   AnsiString bakfile=AddBS(path)+ExtractFileName(name),tmpfile=bak(bakfile,1)+".tmp";
   if (FileExists(bak(bakfile,copies))) DeleteFile(bak(bakfile,copies).c_str());
   if (!CopyFile(name.c_str(),tmpfile.c_str(),false))
   {
      if (FileExists(tmpfile)) zapfile(tmpfile,2);
      lasterror = 1;
      return;
   }

   for (int i=copies; i>=1; i--)
      if (FileExists(bak(bakfile,i-1)))
          rename(bak(bakfile,i-1).c_str(),bak(bakfile,i).c_str());
   rename(tmpfile.c_str(),bak(bakfile,1).c_str());

   TMemoryStream *Org = new TMemoryStream();
   TMemoryStream *Bak = new TMemoryStream();
   Bak->LoadFromFile(bak(bakfile,1));
   Org->LoadFromFile(name);
   if (Org->Size!=Bak->Size || memcmp(Org->Memory,Bak->Memory,Org->Size)!=0)
      lasterror = 2;
   delete Org;
   delete Bak;
}
//---------------------------------------------------------------------------
void __fastcall TBackupThrd::ThreadTerminate(TObject *Sender)
{
   owner->Perform(WM_BACKUPFINISHED,lasterror,NULL);
}
//---------------------------------------------------------------------------
