/*
*  cpkmsg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkMsg.h"
#include "Global.h"
#include "mixmaster.h"
//#include "pgp.h"
//#include "headman.h"
//#include "wipedlgs.h"
//#include "console.h"
//#include "QSver.h"
//#include "fileman.h"
//#include "view.h"
#define DISPLAY(msg) display->Add(msg)
//---------------------------------------------------------------------------
__fastcall TCpkMessage::TCpkMessage(TStringList *message, TStrings *aDisplay,
   TStringList *theFeedback)
{
   Finished = false;
   Cancelled = false;
   Message = message;
   display = aDisplay;

   HeadMan = new THeaderManager(Message);
   From = HeadMan->Get("From: "); HeadMan->Delete("From: ");
   Host = HeadMan->Get("Host: "); HeadMan->Delete("Host: ");
   AnsiString tmpc = HeadMan->GetDat("Chain: ",Message);
   if (tmpc.SubString(tmpc.Length(),1)==";") tmpc.Delete(tmpc.Length(),1);
   HeadMan->Delete("Chain: ");
   HeadMan->Delete("Fcc: ");

   Copies = GetParam(1,tmpc,"=").Trim().ToIntDef(1); if (Copies==0) Copies++;
   Chain = GetParam(0,tmpc,";").Trim(); tmpc = GetParam(1,tmpc,";").Trim();
   Feedback = theFeedback;
}
//---------------------------------------------------------------------------
__fastcall TCpkMessage::~TCpkMessage()
{
   delete HeadMan;
}
//---------------------------------------------------------------------------
long __fastcall TCpkMessage::CpkMessage(TStrings *Message, AnsiString &Chain, int copies,
   TStringList *Feedback)
{
   int i,ret=0;
   BUFFER *msg=buf_new(),*fbk=buf_new();
   if (!msg || !fbk) return -2;

/*TStringList *tmp = new TStringList();
AnsiString y,x,MSG = Message->Text;
for (int i=1; i<MSG.Length(); i++)
{
   int v = (int)MSG[i];
   y = s(v); while (y.Length()<4) y = " "+y;
   x += y;
   if (v==10)
   {
      tmp->Add(x);
      x = "";
   }
}
view(Message->Text+"\n"+tmp->Text);
delete tmp;*/

   msg->sensitive = true; fbk->sensitive = true;
   for (i=0; i<Message->Count; i++)
   {
      AnsiString line = Message->Strings[i];
      buf_append(msg,(byte*)line.c_str(),line.Length());
      buf_append(msg,(byte*)"\n",1);
   }

   //if ((ret=mix_encrypt(MSG_MAIL,msg,Chain.c_str(),copies,fbk))==0)
   //    mix_send();

   Feedback->Text = AnsiString((char*)fbk->data);
   for (i=0; i<Feedback->Count; i++)
      Feedback->Strings[i]=" "+Feedback->Strings[i];
   buf_free(msg); buf_free(fbk);
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall CpkStringInList(AnsiString &String, TStringList *List)
{
   bool isin=false;
   for (int i=0; i<List->Count; i++)
   {
      if (List->Strings[i]==String)
      {
         isin = true;
         break;
      }
   }
   return isin;
}
//---------------------------------------------------------------------------
void CpkDeleteStrings(TStrings *FromList, TStrings *ThatAreInList)
{
   int f=0; while (f<FromList->Count)
   {
      int pos = -1;
      for (int i=0; i<ThatAreInList->Count; i++)
      {
         if (FromList->Strings[f]==ThatAreInList->Strings[i])
         {
            pos = f;
            break;
         }
      }
      if (pos>=0)
         FromList->Delete(pos);
      else
         f++;
   }
}
//---------------------------------------------------------------------------
long __fastcall TCpkMessage::Execute()
{
   long ret=0;
   AnsiString file,text,name,curstr;
   if (Cancelled) { Finished = true; return ret; }

   TStringList *prefiles = new TStringList();
   GetFilenames(prefiles,QUEUEFILES);
   DISPLAY("Cypherpunk encrypting... ");
   Application->ProcessMessages();

   if ((ret=CpkMessage(Message,Chain,Copies,Feedback))==0)
   {
      TStringList *msg = new TStringList();
      TStringList *outfiles = new TStringList();
      GetFilenames(outfiles,QUEUEFILES);
      if (!Cancelled)
      {
         DISPLAY("Cypherpunk reports "+s(Feedback->Count)+" chains: ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            Application->ProcessMessages();
         }

         /*DeleteStrings(outfiles,prefiles);
         for (int i=0; i<outfiles->Count; i++)
         {
            file = outfiles->Strings[i];
            if (!Cancelled)
            {
               curstr = (i+1<10? " ":"")+AnsiString(i+1);
               name = MixmasterChain+" "+curstr+" of "+AnsiString(outfiles->Count);
               msg->LoadFromFile(file); msg->Delete(0);
               msg->Insert(0,Host);
               msg->Insert(1,From);
               MixPoolAdd(msg,name);
            }
            DeleteFile(file.c_str());
         }*/
      }
      delete outfiles;
      delete msg;
   }
   delete prefiles;

   if (!Cancelled)
   {
      if (ret!=0)
      {
         //int lo=LOWORD(ret),hi=HIWORD(ret);
         //DISPLAY("Error: ( "+AnsiString((int)lo)+" , "+AnsiString((int)hi)+" ) encrypting message");
         //switch (hi)
         //{
         //   case 2: Feedback->Add("Client error condition\n"); break;
         //   case 1: Feedback->Add("Commandline error\n"); break;
         //}
         DISPLAY("Cypherpunk reports error condition: ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            Application->ProcessMessages();
         }
      }
   }
   Finished = true;
   return ret;
}
//---------------------------------------------------------------------------
