/*
*  pgpmail.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef pgpmailH
#define pgpmailH
#include "mixmaster.h"
#include "pgpbuffers.h"
//---------------------------------------------------------------------------
bool __fastcall HasPgp();
bool __fastcall HasPgpSdk();
//AnsiString __fastcall PgpDir();

//const AnsiString NoNameYet = "nonameyet";
#define UFS "$$$$"
#define CFS "\250" // a field separator when presenting key values

bool  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle);
void  __fastcall PgpShutDown();
char* __fastcall GetPgpLibVersion();
char* __fastcall GetPgpLibName();

void  __fastcall PgpInitAppAndScrn(TApplication *MainApp, TScreen *MainScrn);
void  __fastcall PgpOpenPersonalKeyring();

char* __fastcall PgpSignMessage(char *Message);
char* __fastcall PgpEncryptMessage(char *Message);
char* __fastcall PgpEncryptSignMessage(char *Message);
char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog);
char* __fastcall PgpVerifyMessage(char *Message);
bool  __fastcall PgpIsConventional(char* Message);
bool  __fastcall PgpGetEncryptList(TForm *Owner, TStrings *Recips, bool CanConv);
bool  __fastcall PgpCheckPGP6NeedsUpdate();
bool  __fastcall PgpUpdateQSKeyrings();
char* __fastcall PgpPubringPkr();
char* __fastcall PgpSecringSkr();
void  __fastcall PgpClearPassphraseCache();
char* __fastcall PgpPath();

bool  __fastcall PgpImportKeys(TForm *Owner, TPGPbuffer *ImpKeys, char* ImportDir);
bool  __fastcall PgpExportKeys(TForm *Owner, TPGPbuffer *PublicKeys,
   TPGPbuffer *SecretKeys, char *SelectedKeyId, char *ExportDir);

typedef void  __fastcall (*PGPINIT)(HINSTANCE, HINSTANCE, TForm*, HWND);
typedef void  __fastcall (*PGPSHUTDOWN)();
typedef char* __fastcall (*GET_PGPLIBVERSION)();
typedef char* __fastcall (*GET_PGPLIBNAME)();

typedef void  __fastcall (*PGPINITAPPANDSCRN)(TApplication*, TScreen*);
typedef void  __fastcall (*PGPOPENPERSONALKEYRING)();

typedef bool  __fastcall (*HASPGPSDK)();
typedef char* __fastcall (*PGP_SIGNMESSAGE)(char*);
typedef char* __fastcall (*PGP_ENCRYPTMESSAGE)(char*);
typedef char* __fastcall (*PGP_ENCRYPTSIGNMESSAGE)(char*);
typedef char* __fastcall (*PGP_DECRYPTVERIFYMESSAGE)(char*,bool);
typedef char* __fastcall (*PGP_VERIFYMESSAGE)(char*);
typedef bool  __fastcall (*PGP_ISCONVENTIONAL)(char*);
typedef char* __fastcall (*PGP_GETARMORKEYS)(char*);
typedef bool  __fastcall (*PGP_GETENCRYPTLIST)(TForm*,TStrings*,bool);
typedef bool  __fastcall (*PGP_CHECKPGP6NEEDSUPDATE)();
typedef bool  __fastcall (*PGP_UPDATEQSKEYRINGS)();
typedef char* __fastcall (*PGP_PUBRINGPKR)();
typedef char* __fastcall (*PGP_SECRINGSKR)();
typedef void  __fastcall (*PGP_CLEARPASSPHRASECACHE)();
typedef char* __fastcall (*PGP_PGPPATH)();

typedef bool  __fastcall (*PGP_IMPORTKEYS)(TForm*,TPGPbuffer*, char*);
typedef bool  __fastcall (*PGP_EXPORTKEYS)(TForm*,TPGPbuffer*,TPGPbuffer*,char*,char*);
//---------------------------------------------------------------------------
extern HINSTANCE hPgpLib;
//extern bool pgpshutdown;
#endif
