/*
*  pickboxdlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PickBoxDlgs.h"
#include "MailboxWins.h"
#include "Fileman.h"
#include "Global.h"
#include "HelpDlgs.h"
//---------------------------------------------------------------------------
#pragma link "OpenDlgs"
#pragma resource "*.dfm"
TPickBoxDlg *PickBoxDlg;
//---------------------------------------------------------------------------
AnsiString __fastcall GetTransferBoxname(AnsiString &Oldname)
{
   AnsiString newbox;
   PickBoxDlg = new TPickBoxDlg(AppMainForm);
   TListBox *list = PickBoxDlg->ItemsBox;
   PickBoxDlg->FromBox = Oldname;
   PickBoxDlg->ShowModal();
   if (PickBoxDlg->ModalResult==mrOk && list->ItemIndex>=0)
      newbox = list->Items->Strings[list->ItemIndex];
   delete PickBoxDlg;
   return newbox;
}
//---------------------------------------------------------------------------
__fastcall TPickBoxDlg::TPickBoxDlg(TComponent* Owner)
  : TOpenDlg(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   LookinBox->ItemIndex = 0;
   LoadMailboxes();
}
//---------------------------------------------------------------------------
void __fastcall TPickBoxDlg::ItemsBoxDblClick(TObject *Sender)
{
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TPickBoxDlg::LoadMailboxes()
{
   int pos;
   TStringList *list = new TStringList(); list->Sorted = true;
   GetAppData(list,UserMailboxes);
   if (list->IndexOf("outbox")<0) list->Add("outbox");
   if ((pos=list->IndexOf(FromBox))>=0)
      list->Delete(pos);
   ItemsBox->Items->Text = list->Text;
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TPickBoxDlg::NewBoxBtnClick(TObject *Sender)
{
   AnsiString newname = CreateMailbox();
   if (!newname.IsEmpty())
   {
      OpenMailbox(newname); ItemsBox->Clear();
      Application->ProcessMessages(); Sleep(200);
      LoadMailboxes();
   }
}
//---------------------------------------------------------------------------
void __fastcall TPickBoxDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("Messages","Transfering Messages","",NULL);
}
//---------------------------------------------------------------------------
void __fastcall TPickBoxDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ItemsBox->ItemIndex>=0)
   {
      if (FromBox==ItemsBox->Items->Strings[ItemsBox->ItemIndex])//newbox
      {
         MsgBoxHwnd(Handle,
            s("The source and destination mailboxs are the same.\n")+
            s("You can't do that!"),
            s("Name Collision"),
            MB_OK);
         CanClose = false;
      }
   }
}
//---------------------------------------------------------------------------

