/*
*  NewsProfDlgs2.cpp
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "global.h"
#include "NewsProfDlgs2.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNewsProfDlg2 *NewsProfDlg2;
//---------------------------------------------------------------------------

bool __fastcall NewAccountProfile2(TForm *Owner, AnsiString &Acct, TStrings *Existing)
{
   bool ok = false;

   NewsProfDlg2 = new TNewsProfDlg2(Owner, Acct);
   NewsProfDlg2->existing = Existing;

   NewsProfDlg2->ShowModal();
   if (NewsProfDlg2->ModalResult == mrOk && NewsProfDlg2->modified)
   {
      Acct = NewsProfDlg2->acct->CommaText;
      ok = true;
   }

   delete NewsProfDlg2;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall EditAccountProfile2(TForm *Owner, AnsiString &Acct)
{
   bool ok = false;
   NewsProfDlg2 = new TNewsProfDlg2(Owner, Acct);

   NewsProfDlg2->ShowModal();
   if (NewsProfDlg2->ModalResult == mrOk && NewsProfDlg2->modified)
   {
      Acct = NewsProfDlg2->acct->CommaText;
      ok = true;
   }

   delete NewsProfDlg2;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNewsProfDlg2::TNewsProfDlg2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TNewsProfDlg2::TNewsProfDlg2(TComponent* Owner, AnsiString Acct)
        : TForm(Owner)
{
   CenterDialog(this, Owner);
   acct = new TStringList();
   acct->CommaText = Acct;

   NNTPHost->Text = acct->Values["server"];
   AccountUID->Text = acct->Values["login"];
   Password->Text = acct->Values["password"];
   Remember->Checked = !Password->Text.IsEmpty();
   acct->Values["remember"] = Remember->Checked ? "1" : "0";
   LastArticles->Lines->CommaText = acct->Values["newsgroups"];
}
//---------------------------------------------------------------------------

__fastcall TNewsProfDlg2::~TNewsProfDlg2()
{
   delete acct;
}
//---------------------------------------------------------------------------

void __fastcall TNewsProfDlg2::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk && NNTPHost->Text.IsEmpty())
   {
      InfoBox(this, "News Server field is required!      ", MB_OK);
      CanClose = false;
      return;
   }

   modified = Modified();

   if (modified)
   {
      if (ModalResult == mrCancel)
      {
         switch (this,
            ConfirmBox(this, "Your account data is changed. Save your changes?    ", MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: modified = false;
               return;
         }
      }
   }

   if (modified)
   {
      AnsiString item, login, server;
      login = AccountUID->Text;
      server = NNTPHost->Text;
      if (!login.IsEmpty())
         item = login;
      if (!item.IsEmpty())
         item += "@";
      item += server;

      acct->Clear();
      acct->Values["sort"] = item;
      acct->Values["server"] = NNTPHost->Text;
      acct->Values["login"] = AccountUID->Text;
      if (Remember->Checked)
         acct->Values["password"] = Password->Text;
      acct->Values["newsgroups"] = LastArticles->Lines->CommaText;
   }

   if (ModalResult == mrOk && !modified)
      ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

bool __fastcall TNewsProfDlg2::Modified()
{
   if (LastArticles->Lines->CommaText != acct->Values["newsgroups"])
      return true;

   if (AnsiString(Remember->Checked ? "1" : "0") != acct->Values["remember"])
      return true;

   if (Password->Text != acct->Values["password"])
      return true;

   if (AccountUID->Text != acct->Values["login"])
      return true;

   if (NNTPHost->Text != acct->Values["server"])
      return true;

   return false;
}
//---------------------------------------------------------------------------

void __fastcall TNewsProfDlg2::LastArticlesSelectionChange(TObject *Sender)
{
   int index = LastArticles->Perform(EM_EXLINEFROMCHAR, 0, LastArticles->SelStart);
   NextBtn->Enabled = LastArticles->Lines->Strings[index].Pos("=") > 0;
}
//---------------------------------------------------------------------------
void __fastcall TNewsProfDlg2::NextBtnClick(TObject *Sender)
{
   int index = LastArticles->Perform(EM_EXLINEFROMCHAR, 0, LastArticles->SelStart);
   AnsiString line = LastArticles->Lines->Strings[index];
   int article = line.SubString(line.Pos("=") + 1, 32).ToIntDef(0);
   LastArticles->Lines->Strings[index] = line.SubString(1, line.Pos("=")) + IntToStr(++article); 
}
//---------------------------------------------------------------------------
