/*
*  NewsTransDlgs.cpp
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NewsTransDlgs.h"
#include "NewsProfDlgs2.h"
#include "NewsManDlgs2.h"
#include "newsmail.h"
#include "headman.h"
#include "fileman.h"
#include "Global.h"
#include "WipeDlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNewsTransDlg *NewsTransDlg;
//---------------------------------------------------------------------------

bool __fastcall HandleNewsgroupMail(TForm *Owner)
{
   if (FileExists(AppNewsDat))
   {
      MoveAppNewsDat2AppMainDat(Owner);
      zapfile(AppNewsDat,2);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall MoveAppNewsDat2AppMainDat(TForm *Owner)
{
   NewsTransDlg = new TNewsTransDlg(Owner);
   NewsTransDlg->ShowModal();
   bool move = NewsTransDlg->ModalResult==mrOk;
   delete NewsTransDlg;
   return move;
}
//---------------------------------------------------------------------------

__fastcall TNewsTransDlg::TNewsTransDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this, Owner);

   subjects = new TStringList();
   TStringList *usubs = new TStringList();

   GetAppData(subjects, "nymdata", AppNewsIni);
   GetAppData(usubs, "userdata", AppNewsIni);
   subjects->AddStrings(usubs);

   delete usubs;

   // get list of unticked items and delete these from subs
   TStringList *noticks = new TStringList();
   GetAppData(noticks, "notticked", AppNewsIni);

   for(int i = 0; i < noticks-> Count; i++)
   {
      int index = subjects->IndexOf(noticks->Strings[i]);
      if (index >= 0)
      {
         subjects->Delete(index);
      }
   }
   delete noticks;

   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

__fastcall TNewsTransDlg::~TNewsTransDlg()
{
   delete subjects;
}
//---------------------------------------------------------------------------

void __fastcall TNewsTransDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   TStringList *msg = new TStringList();
   TStringList *msgs = new TStringList();
   THeaderManager *headers = new THeaderManager();

   GetAppData(msgs,UserMailboxes+PS+"inbox",AppNewsDat);
   hEsubLib = LoadLibrary("psesub32.dll");

   int c = 0; for (int m = 0; m < msgs->Count; m++)
   {
      Panel1->Caption = "scanning " + IntToStr(m + 1) + " of " + IntToStr(msgs->Count) + " (" + IntToStr(c) + ")";
      Application->ProcessMessages();

      GetAppData(msg, UserMailboxes+PS+"inbox"+PS+msgs->Strings[m], AppNewsDat);
      assert(msg->Count > 0);

      AnsiString newsgroup = GetToken(1, msg->Strings[0], "|");
      msg->Delete(0);

      if (IsNewsgroupSubjectMatch(newsgroup, msg))
      {
         PutAppData(UserMailboxes+PS+"inbox"+PS+headers->InIndexString(msg), msg, AppMainDat);
         c++;
      }
   }

   HWND hWndQS;
   if ((hWndQS = FindWindow("TQSMainWin",NULL)) != NULL && IsWindowVisible(hWndQS))
   {
     SendMessage(hWndQS,WM_OPENINBOX,0,NULL);
   }

   FreeLibrary(hEsubLib);
   hEsubLib = NULL;

   delete headers;
   delete msgs;
   delete msg;

   ModalResult = mrOk;
}
//---------------------------------------------------------------------------

bool __fastcall TNewsTransDlg::IsNewsgroupSubjectMatch(const AnsiString &newsgroup, TStrings *message)
{
   THeaderManager *hm = new THeaderManager(message);
   AnsiString sub, grp, item, key, subject = hm->GetDat("Subject: ");
   delete hm;

   bool match = false;
   for (int i = 0; i < subjects->Count; i++)
   {
      item = subjects->Strings[i];
      assert(item.Pos("\255") > 1);

      grp = GetToken(0, item, "\255");
      if (grp != newsgroup)
         continue;

      sub = GetToken(1, item, "\255");
      key = GetToken(2, item, "\255");

      // test with esub first
      if (TestSubject(subject, sub, key) == 0)
      {
         THeadMan *headers = new THeadMan(message);
         int index = headers->Delete("Subject: ");
         message->Insert(index, "Subject: " + sub + "  <es>");
         delete headers;
         match = true;
         break;
      }

      // test without esub
      if (key.IsEmpty() && sub == subject)
      {
         match = true;
         break;
      }
   }

   return match;
}
//---------------------------------------------------------------------------
