//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "GetBarRemDlgs.h"
#include "ViewBarredDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGetBarRemDlg *GetBarRemDlg;
//---------------------------------------------------------------------------

bool __fastcall GetBarredRemailerSpec(TForm *Owner, AnsiString &Name,
   AnsiString &Address, bool &Mix, bool &Cpunk)
{
   bool got = false;
   GetBarRemDlg = new TGetBarRemDlg(Owner);
   GetBarRemDlg->mixcheck = Mix;
   GetBarRemDlg->cpkcheck = Cpunk;
   GetBarRemDlg->Edit1->Text = Name;
   GetBarRemDlg->Edit2->Text = Address;
   GetBarRemDlg->Edit1->Modified = false;
   GetBarRemDlg->Edit2->Modified = false;
   GetBarRemDlg->ShowModal();
   if (GetBarRemDlg->ModalResult == mrOk)
   {
      Cpunk = GetBarRemDlg->CpkBox->Checked;
      Mix = GetBarRemDlg->MixBox->Checked;
      Address = GetBarRemDlg->Edit2->Text;
      Name = GetBarRemDlg->Edit1->Text;

      got = true;
   }
   delete GetBarRemDlg;
   return got;
}

//---------------------------------------------------------------------------
// TGetBarRemDlg
//---------------------------------------------------------------------------

__fastcall TGetBarRemDlg::TGetBarRemDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TGetBarRemDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Edit1->Modified || Edit2->Modified || mixcheck != MixBox->Checked || cpkcheck != CpkBox->Checked)
   {
      if (ModalResult == mrCancel)
      {
         switch (MsgBox(this, "Your inputs are modified. Save your changes?",
            mtConfirmation, MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: return;
         }
      }

      if (Edit1->Text.IsEmpty())// || Edit2->Text.IsEmpty())
      {
         MsgBox(this, "'Name' field is required.",
            mtError, MB_OK);
         CanClose = false;
         return;
      }

      /*if (Edit2->Text.Pos("@") == 0)
      {
         MsgBox(this, "The 'Address' field requires an email address. Your entry is not.",
            mtError, MB_OK);
         CanClose = false;
         return;
      }*/

      if (!MixBox->Checked && !CpkBox->Checked)
      {
         MsgBox(this, "You must select 'Mixmaster', 'Cypherpunk', or both.",
            mtError, MB_OK);
         CanClose = false;
         return;
      }
   }
   else ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

