//---------------------------------------------------------------------------
#ifndef Mixmaster2H
#define Mixmaster2H
//---------------------------------------------------------------------------

bool __fastcall HasMix();
AnsiString __fastcall MixDir();

bool __fastcall InitMixmaster(TComponent *Owner);  // must be called first
void __fastcall ShutDownMixmaster();
void __fastcall ShutDownMix();

typedef unsigned char byte;
typedef struct {
  byte *data;
  long length;
  long ptr;
  long size;
  byte sensitive;
} BUFFER;


class TMixmaster3 : public TComponent
{
private:
   bool FFailedInit;
   TComponent *FOwner;
   AnsiString FDirectory;
   //HANDLE hSSLLib, hMIXLib;
   // MIXLIB
   int  __fastcall mix_init(char *mixdir);
   void __fastcall mix_exit();
   void __fastcall rand_bytes(unsigned char *buf, int num);
   int  __fastcall data_encrypt(char** data, long& datlen, char* password, int paslen);
   int  __fastcall data_decrypt(char** data, long& datlen, char* password, int paslen);
   int  __fastcall pgp_encrypt(int mode, BUFFER *message, BUFFER *encr,
      BUFFER *sigid, BUFFER *pass, char *pubring, char *secring);
   int  __fastcall pgp_mailenc(int mode, BUFFER *message, char *sigid,
      BUFFER *pass, char *pubring, char *secring);
   int  __fastcall pgp_decrypt(BUFFER *message, BUFFER *pass, BUFFER *sig,
      char *pubring, char *secring);

public:
   __property bool FailedInit = { read=FFailedInit };
   __property AnsiString Directory  = { read=FDirectory };

   virtual __fastcall TMixmaster3(TComponent* Owner);
   virtual __fastcall TMixmaster3(TComponent* Owner, const AnsiString& Mixdir);
   virtual __fastcall~TMixmaster3();
};
extern TMixmaster3 *Mixmaster;

// BUFFERS
BUFFER* __fastcall buf_new(void);
int __fastcall buf_free(BUFFER *buf);
int __fastcall buf_append(BUFFER *buffer, byte *mess, int len);
int buf_readfile(BUFFER *buffer, char *filename);
int __fastcall buf_reset(BUFFER *buf);
void __fastcall buf_move(BUFFER *dest, BUFFER *src);
int __fastcall buf_cat(BUFFER *to, BUFFER *from);
int __fastcall buf_clear(BUFFER *buffer);
int __fastcall buf_appends(BUFFER *buffer, char *s);
int __fastcall buf_appendl(BUFFER *to, long l);
int __fastcall buf_appendc(BUFFER *to, byte b);
int __fastcall buf_rest(BUFFER *to, BUFFER *from);
int __fastcall buf_appendi(BUFFER *to, int i);
int __fastcall buf_nl(BUFFER *b);
int __fastcall buf_getheader(BUFFER *buffer, BUFFER *field, BUFFER *content);
int __fastcall buf_getline(BUFFER *buffer, BUFFER *line);
int __fastcall decode(BUFFER *in, BUFFER *out);
int __fastcall encode(BUFFER *in, int linelen);

// MixLib Function Protos
typedef int  (*MIX_INIT)(char*);
typedef void (*MIX_EXIT)();
typedef void (*RAND_BYTES)(unsigned char*, int);
typedef BUFFER* (*BUF_NEW)(void);
typedef int (*DECODE)(BUFFER*, BUFFER*);
typedef int (*ENCODE)(BUFFER*, int);
typedef int (*BUF_FREE)(BUFFER*);
typedef int (*BUF_APPEND)(BUFFER*, byte*, int);
typedef int (*PGP_ENCRYPT)(int, BUFFER*, BUFFER*, BUFFER*, BUFFER*, char*, char*);
typedef int (*PGP_MAILENC)(int, BUFFER*, char*, BUFFER*, char*, char*);

typedef int (*PGP_DECRYPT)(BUFFER*, BUFFER*, BUFFER*, char*, char*);

typedef int (*BUF_RESET)(BUFFER*);

typedef void(*BUF_MOVE)(BUFFER*, BUFFER*);

typedef int (*BUF_CAT)(BUFFER*, BUFFER*);

typedef int (*BUF_CLEAR)(BUFFER*);

typedef int (*BUF_APPENDS)(BUFFER*, char*);
typedef int (*BUF_APPENDL)(BUFFER*, long);

typedef int (*BUF_APPENDC)(BUFFER*, byte);

typedef int (*BUF_REST)(BUFFER*, BUFFER*);

typedef int (*BUF_APPENDI)(BUFFER*, int);

typedef int (*BUF_GET)(BUFFER*, BUFFER*, int);

typedef int (*BUF_GETHEADER)(BUFFER*, BUFFER*, BUFFER*);

typedef int (*BUF_GETLINE)(BUFFER*, BUFFER*);


// BUFFERS copy

int __fastcall buf_sets(BUFFER *buffer, char *s); //copy
int __fastcall buf_rewind(BUFFER *buffer); //copy
int __fastcall buf_getc(BUFFER *buffer); // copy
long __fastcall buf_getl(BUFFER *b); // copy
int __fastcall buf_geti(BUFFER *b); // copy
int __fastcall buf_get(BUFFER *buffer, BUFFER *to, int n); // copy

#define PGP_CONVENTIONAL 4

#define PGP_NOARMOR 32

#define BUFFER_MAX 2*1024*1024
#define BUFSIZE 4096

extern HINSTANCE hMIXLib;
extern HINSTANCE hSSLLib;
//---------------------------------------------------------------------------
#endif
