//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <inifiles.hpp>

#include "global2.h"
#include "ProxyDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TProxyDlg *ProxyDlg;
//---------------------------------------------------------------------------

bool __fastcall OpenProxyManager(TForm *Owner)
{
   ProxyDlg = new TProxyDlg(Owner);
   ProxyDlg->ShowModal();
   bool ok = ProxyDlg->ModalResult == mrOk;
   delete ProxyDlg;
   return ok;
}

//---------------------------------------------------------------------------
// ProxyDlg
//---------------------------------------------------------------------------

__fastcall TProxyDlg::TProxyDlg(TComponent* Owner)
        : TForm(Owner)
{
   TIniFile *ini = new TIniFile(AppIni());
   ProxyBox->Checked = ini->ReadBool("proxy", "useproxy", false);
   ProxyAuthBox->Checked = ini->ReadBool("proxy", "authenticate", false);
   ProxyHost->Text = ini->ReadString("proxy", "host", "");
   ProxyPort->Text = ini->ReadString("proxy", "port", "0");
   ProxyUserID->Text = ini->ReadString("proxy", "userid", "");
   ProxyPassword->Text = ini->ReadString("proxy", "password", "");
   ProxyPasswordHide->Checked = ini->ReadBool("proxy", "passwdhidetyping", true);
   ProxyPassword->PasswordChar = ProxyPasswordHide->Checked ? '*' : '\0';
   SocksVerBox->ItemIndex = ini->ReadInteger("proxy", "socksversionindex", 0);
   delete ini;

   UseProxy = ProxyBox->Checked;
   AuthChecked = ProxyAuthBox->Checked;
   HideChecked = ProxyPasswordHide->Checked;
   SocksVer = SocksVerBox->ItemIndex;

   ProxyPassword->Modified = false;
   ProxyUserID->Modified = false;
   ProxyHost->Modified = false;
   ProxyPort->Modified = false;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TProxyDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Modified())
   {
      if (ModalResult == mrCancel)
      {
         switch (MsgBox(this, "Your proxy profile is modified. Save your changes?",
            mtConfirmation, MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: return;
         }
      }

      TIniFile *ini = new TIniFile(AppIni());
      ini->WriteBool("proxy", "useproxy", ProxyBox->Checked);
      ini->WriteBool("proxy", "authenticate", ProxyAuthBox->Checked);
      ini->WriteString("proxy", "host", ProxyHost->Text);
      ini->WriteInteger("proxy", "port", ProxyPort->Text.ToIntDef(80));
      ini->WriteString("proxy", "userid", ProxyUserID->Text);
      ini->WriteString("proxy", "password", ProxyPassword->Text);
      ini->WriteBool("proxy", "passwdhidetyping", ProxyPasswordHide->Checked);
      ini->WriteInteger("proxy", "socksversionindex", SocksVerBox->ItemIndex);
      delete ini;
   }
}
//---------------------------------------------------------------------------

bool __fastcall TProxyDlg::Modified()
{
   bool mod = ProxyHost->Modified;
   if (!mod) mod = ProxyBox->Checked != UseProxy;
   if (!mod) mod = ProxyAuthBox->Checked != AuthChecked;
   if (!mod) mod = ProxyHost->Modified;
   if (!mod) mod = ProxyPort->Modified;
   if (!mod) mod = ProxyUserID->Modified;
   if (!mod) mod = ProxyPassword->Modified;
   if (!mod) mod = ProxyPasswordHide->Checked != HideChecked;
   if (!mod) mod = SocksVerBox->ItemIndex != SocksVer;
   return mod;
}
//---------------------------------------------------------------------------
#pragma argsused
void __fastcall TProxyDlg::ProxyPasswordHideClick(TObject *Sender)
{
   TCheckBox *checkbox = dynamic_cast<TCheckBox*>(Sender);
   if (checkbox)
   {
      ProxyPassword->PasswordChar = checkbox->Checked ? '*' : '\0';
   }
}
//---------------------------------------------------------------------------

